﻿//*************************************************}
//                                                 }
//       Class: RFIDFeig                           }
//       Programmed with Visual Studio 2008        }
//       Programmed by Sascha Haveloh              }
//       V1.0 Beata                                } 
//       not all function/void work on PDA         }                  
//                                                 }
//*************************************************}
// Version 1.0 - 29.10.2012  
// Testing UHF Reader
// Import Class..RFIDFeigBartec.cs
//

using System;
using System.Linq;
using System.Collections.Generic;
using System.Text;
using System.Runtime;
using System.Runtime.InteropServices;
using System.Threading;
using System.IO;

public class RFIDFeig
   
{

    public RFIDFeig()  // public override void New() ... delphi..inof..contructor create...
    {
        New_Init();
    }


    ~RFIDFeig() // protected override void Finalize() ... delphi info..destroy...
    {
        ReaderUnload();
    }


    /*public override void New() // VB.NET   in use at CSharp...
    {
        Read_Array = new byte[256];
        Write_Array = new byte[256];
        My_ComArray = new byte[4];
        Config_Array = new byte[14];
        cReqData = new byte[2];
        cRspData = new byte[512];
        Info_Array = new byte[512];
        UID_Array = new byte[12];
        UID_Array24 = new byte[19];
        Key_Array = new byte[10];
        SelMifare_Array = new byte[10];
        Value_Array = new byte[17];
        InfoReader = new string[6];
        ReadMi_Array = new byte[4];
        WriteMi_Array = new byte[22];
        Error_Array = new byte[256];
    }*)

    /*protected override void Finalize() // VB.NET..not in use at CSharp...
    {
        ReaderUnload();
        base.Finalize();
    }*/


    public sealed class ControlChars
    {
        public const char Back = '\b';
        public const char Cr = '\r';
        public const string CrLf = "\r\n";
        public const char FormFeed = '\f';
        public const char Lf = '\n';
        public const string NewLine = "\r\n";
        public const char NullChar = '\0';
        public const char Quote = '"';
        public const char Tab = '\t';
        public const char VerticalTab = '\v';
    }



	#region "FEIG constants WM_USER"

	public const int WM_USER = 0x400;
	public const int WM_USER_CTS = WM_USER + 5;
	public const int WM_USER_RTS = WM_USER + 6;
	public const int WM_USER_DEVICE_DISCONNECT = WM_USER + 7;

	public const int WM_USER_DEVICE_CONNECT = WM_USER + 8;
	#endregion

	#region "FEUSB constans"

	// FEUSB error codes

	// common errors
	public const int FEUSB_ERR_EMPTY_DEVICELIST = -1100;
	public const int FEUSB_ERR_EMPTY_SCANLIST = -1101;
	public const int FEUSB_ERR_POINTER_IS_NULL = -1102;
	public const int FEUSB_ERR_NO_MORE_MEM = -1103;
	public const int FEUSB_ERR_SET_CONFIGURATION = -1104;
	public const int FEUSB_ERR_KERNEL = -1105;
	public const int FEUSB_ERR_UNSUPPORTED_OPTION = -1106;

	public const int FEUSB_ERR_UNSUPPORTED_FUNCTION = -1107;
	// error while scanning
	public const int FEUSB_ERR_NO_FEIG_DEVICE = -1110;
	public const int FEUSB_ERR_SEARCH_MISMATCH = -1111;
	public const int FEUSB_ERR_NO_DEVICE_FOUND = -1112;
	public const int FEUSB_ERR_DEVICE_IS_SCANNED = -1113;

	public const int FEUSB_ERR_SCANLIST_OVERFLOW = -1114;
	// handle errors
	public const int FEUSB_ERR_UNKNOWN_HND = -1120;
	public const int FEUSB_ERR_HND_IS_NULL = -1121;
	public const int FEUSB_ERR_HND_IS_NEGATIVE = -1122;

	public const int FEUSB_ERR_NO_HND_FOUND = -1123;
	// communication errors
	public const int FEUSB_ERR_TIMEOUT = -1130;
	public const int FEUSB_ERR_NO_SENDDATA = -1131;
	public const int FEUSB_ERR_UNKNOWN_INTERFACE = -1132;
	public const int FEUSB_ERR_UNKNOWN_DIRECTION = -1133;
	public const int FEUSB_ERR_RECBUF_TOO_SMALL = -1134;
	public const int FEUSB_ERR_SENDDATA_LEN = -1135;
	public const int FEUSB_ERR_UNKNOWN_DESCRIPTOR_TYPE = -1136;
	public const int FEUSB_ERR_DEVICE_NOT_PRESENT = -1137;

	public const int FEUSB_ERR_TRANSMIT_PROCESS = -1138;
	// open/close device errors
	public const int FEUSB_ERR_DEVICE_NOT_SCANNED = -1140;
	public const int FEUSB_ERR_DEVHND_NOT_IN_SCANLIST = -1141;

	public const int FEUSB_ERR_DRIVERLIST = -1142;
	// parameter errors
	public const int FEUSB_ERR_UNKNOWN_PARAMETER = -1150;
	public const int FEUSB_ERR_PARAMETER_OUT_OF_RANGE = -1151;
	public const int FEUSB_ERR_ODD_PARAMETERSTRING = -1152;
	public const int FEUSB_ERR_INDEX_OUT_OF_RANGE = -1153;
	public const int FEUSB_ERR_UNKNOWN_SCANOPTION = -1154;

	public const int FEUSB_ERR_UNKNOWN_ERRORCODE = -1155;
	// identification errors
	public const int FEUSB_ERR_DEV_DESC_LENGTH = -1160;
	public const int FEUSB_ERR_CFG_DESC_LENGTH = -1161;
	public const int FEUSB_ERR_INTF_DESC_LENGTH = -1162;
	public const int FEUSB_ERR_ENDP_DESC_LENGTH = -1163;
	public const int FEUSB_ERR_HID_DESC_LENGTH = -1164;
	public const int FEUSB_ERR_STRG_DESC_LENGTH = -1165;
	public const int FEUSB_ERR_READ_DEV_DESCRIPTOR = -1166;
	public const int FEUSB_ERR_READ_CFG_DESCRIPTOR = -1167;

	public const int FEUSB_ERR_READ_STRG_DESCRIPTOR = -1168;
	public const int FEUSB_ERR_MAX_INTERFACES = -1170;
	public const int FEUSB_ERR_MAX_ENDPOINTS = -1171;

	public const int FEUSB_ERR_MAX_STRINGS = -1172;

	// constants for dynamic load of library

	// miscellaneous functions
	public const int FEUSB_GET_DLL_VERSION = 1100;
	public const int FEUSB_GET_DRV_VERSION = 1101;
	public const int FEUSB_GET_ERROR_TEXT = 1102;

	public const int FEUSB_GET_LAST_ERROR = 1103;
	// function for scan-list					
	public const int FEUSB_SCAN_ = 1110;
	public const int FEUSB_SCAN_AND_OPEN_ = 1111;
	public const int FEUSB_GET_SCAN_LIST_PARA = 1112;
	public const int FEUSB_GET_SCAN_LIST_SIZE = 1113;

	public const int FEUSB_CLEAR_SCAN_LIST = 1114;
	// functions for event notification			
	public const int FEUSB_ADD_EVENT_HANDLER = 1120;

	public const int FEUSB_DEL_EVENT_HANDLER = 1121;
	// device functions							
	public const int FEUSB_OPEN_DEVICE = 1130;
	public const int FEUSB_CLOSE_DEVICE = 1131;
	public const int FEUSB_IS_DEVICE_PRESENT = 1132;
	public const int FEUSB_GET_DEVICE_LIST = 1133;
	public const int FEUSB_GET_DEVICE_PARA = 1134;
	public const int FEUSB_SET_DEVICE_PARA = 1135;

	public const int FEUSB_GET_DEVICE_HND = 1136;
	// communication function					
	public const int FEUSB_TRANSCEIVE_ = 1140;
	public const int FEUSB_TRANSMIT_ = 1141;

	public const int FEUSB_RECEIVE_ = 1142;

	// constants for uiFlag in FEUSB_MSG_INIT
		//not useable in Visual Basic
	public const int FEUSB_THREAD_ID = 1;
		//not useable in Visual Basic
	public const int FEUSB_WND_HWND = 2;

	public const int FEUSB_CALLBACK = 3;
	// defines for uiUse in FEUSB_EVENT_INIT
	public const int FEUSB_DEV_CONNECT_EVENT = 1;

	public const int FEUSB_DEV_DISCONNECT_EVENT = 2;
	// interface constants
	// scan options
	public const int FEUSB_SCAN_FIRST = 0x1;
	public const int FEUSB_SCAN_NEXT = 0x2;
	public const int FEUSB_SCAN_NEW = 0x3;
	public const int FEUSB_SCAN_ALL = 0xf;
	public const int FEUSB_SCAN_SEARCH = 0x10000;

	public const int FEUSB_SCAN_PACK = 0x20000;
	// search options
	public const int FEUSB_SEARCH_FAMILY = 0x1;
	public const int FEUSB_SEARCH_PRODUCT = 0x2;

	public const int FEUSB_SEARCH_DEVICEID = 0x4;
	// communication directions
	public const int FEUSB_DIR_IN = 1;

	public const int FEUSB_DIR_OUT = 2;
	// Interface names
	public const string FEUSB_INTERFACE_OBID_RCI = "OBID-RCI";

	public const string FEUSB_INTERFACE_OBID_RCI_V2 = "OBID-RCI2";


	// structure for transfering callback functions
	public struct FEUSB_EVENT_INIT
	{
			// defines the event (e.g. FEUSB_DEV_CONNECT_EVENT)
		public int uiUse;
			// set always to 0 - in Visual Basic not used !!
		public int uiMsg;
			// specifies the use of the Variant (e.g. FEUSB_CALLBACK)
		public int uiFlag;
			// for callback-function
		public int Method;
	}

	//type  FEUSB_SCANSEARCH = record
	// iMask:                          Integer;
	//cFamily,cProduct,cInterface:    array[0..24] of Char;
	//cDeviceID:                      array[0..8] of Char;
	//end;

	// new datatype
	//<StructLayout(LayoutKind.Sequential)> _

	//typedef struct _FEUSB_SCANSEARCH
	//{
	//	int		iMask;
	//	char	cFamilyName[25];
	//	char	cDeviceName[25];
	//	char	cInterface[25];
	//	char	cDeviceID[16];

	//} FEUSB_SCANSEARCH;

	[StructLayout(LayoutKind.Sequential, CharSet = CharSet.Auto)]
	public struct FEUSB_SCANSEARCH
	{
		public short iMask;
        [MarshalAs(UnmanagedType.ByValTStr,SizeConst = 25)]
        //[MarshalAs(UnmanagedType.ByValTStr, sizeconst = 25)]
			// 25
		public string cFamily;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 25)]
			// 25
		public string cProduct;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 25)]
			// 25
		public string cInterface;
		[MarshalAs(UnmanagedType.ByValTStr, SizeConst = 9)]
			// 9
		public string cDeviceID;
	}


	[System.Runtime.InteropServices.StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential)]
	public struct FEUSB_SCANSEARCH1
	{
		public int iMask;
		public string cFamily;
		public string cProduct;
		public string cInterface;
		public string cDeviceID;
	}

	[System.Runtime.InteropServices.StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential)]
	public struct FEUSB_SCANSEARCH_BYTE
	{
		public short iMask;
		public byte[] cFamily;
		public byte[] cProduct;
		public byte[] cInterface;
		public byte[] cDeviceID;
	}

	#endregion

	#region "FEUSB DLL"

	// #####################################################
	// FEUSB DLL 
	// #####################################################

	// common functions
	[DllImport(dllName_usb, EntryPoint = "FEUSB_GetDLLVersion", SetLastError = true)]
	private static extern void FEUSB_GetDLLVersion(string cVersion);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_GetErrorText", SetLastError = true)]
	private static extern int FEUSB_GetErrorText(int iError, byte[] cErrorText);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_GetLastError", SetLastError = true)]
	private static extern int FEUSB_GetLastError(int iDevHnd, int iErrorCode, string cErrorText);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_Scan", SetLastError = true)]
	private static extern int FEUSB_Scan(int iScanOpt, ref FEUSB_SCANSEARCH_BYTE SearchOpt);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_ScanAndOpen", SetLastError = true)]
	private static extern int FEUSB_ScanAndOpen(int iScanOpt, ref FEUSB_SCANSEARCH pSearchOpt);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_GetScanListPara", SetLastError = true)]
	private static extern int FEUSB_GetScanListPara(int iIndex, string cPara, byte[] cValue);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_GetScanListSize", SetLastError = true)]
	private static extern int FEUSB_GetScanListSize();
	[DllImport(dllName_usb, EntryPoint = "FEUSB_ClearScanList", SetLastError = true)]
	private static extern void FEUSB_ClearScanList();
	// functions for event notification
	[DllImport(dllName_usb, EntryPoint = "FEUSB_AddEventHandler", SetLastError = true)]
	private static extern int FEUSB_AddEventHandler(int iPortHnd, FEUSB_EVENT_INIT pInit);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_DelEventHandler", SetLastError = true)]
	private static extern int FEUSB_DelEventHandler(int iPortHnd, FEUSB_EVENT_INIT pInit);
	// device functions
	[DllImport(dllName_usb, EntryPoint = "FEUSB_OpenDevice", SetLastError = true)]
	private static extern int FEUSB_OpenDevice(long dwDeviceID);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_CloseDevice", SetLastError = true)]
	private static extern int FEUSB_CloseDevice(int iDevHnd);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_IsDevicePresent", SetLastError = true)]
	private static extern int FEUSB_IsDevicePresent(int iDevHnd);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_GetDeviceList", SetLastError = true)]
	private static extern int FEUSB_GetDeviceList(int iNext);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_GetDeviceHnd", SetLastError = true)]
	private static extern int FEUSB_GetDeviceHnd(int dwDeviceID);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_GetDevicePara", SetLastError = true)]
    private static extern int FEUSB_GetDevicePara(int iDeviceHnd, string cParaID, string cValue);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_SetDevicePara", SetLastError = true)]
	private static extern int FEUSB_SetDevicePara(int iDeviceHnd, string cParaID, string cValue);
	// communication function
	[DllImport(dllName_usb, EntryPoint = "FEUSB_Transceive", SetLastError = true)]
	private static extern int FEUSB_Transceive(int iDevHnd, string cInterface, int iDir, string cSendData, int iSendLen, string cRecData, int iRecLen);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_Transmit", SetLastError = true)]
	private static extern int FEUSB_Transmit(int iDevHnd, string cInterface, string cSendData, int iSendLen);
	[DllImport(dllName_usb, EntryPoint = "FEUSB_Receive", SetLastError = true)]
	private static extern int FEUSB_Receive(int iDevHnd, string cInterface, string cRecData, int iRecLen);

	#endregion


	#region "FECOM constants"
	// #####################################################
	// FECOM constants
	// #####################################################

	public const int FECOM_ERR_NEWPORT_FAILURE = -1000;
	public const int FECOM_ERR_EMPTY_LIST = -1001;
	public const int FECOM_ERR_POINTER_IS_NULL = -1002;
	public const int FECOM_ERR_NO_MEMORY = -1003;
	public const int FECOM_ERR_UNSUPPORTED_HARDWARE = -1004;
	public const int FECOM_ERR_PORT_NOT_FOUND = -1005;

	public const int FECOM_ERR_UNSUPPORTED = -1006;
	// error while open the port
	public const int FECOM_ERR_NO_PORT = -1010;
	public const int FECOM_ERR_NO_CONNECT = -1011;
	public const int FECOM_ERR_LINK_ID = -1012;

	public const int FECOM_ERR_PORT_IS_OPEN = -1013;
	// handle errors
	public const int FECOM_ERR_UNKNOWN_HND = -1020;
	public const int FECOM_ERR_HND_IS_NULL = -1021;
	public const int FECOM_ERR_HND_IS_NEGATIVE = -1022;

	public const int FECOM_ERR_NO_HND_FOUND = -1023;
	// communication errors
	public const int FECOM_ERR_TIMEOUT = -1030;
	public const int FECOM_ERR_NO_SENDPROTOCOL = -1031;
	public const int FECOM_ERR_RECEIVE_PROCESS = -1032;
	public const int FECOM_ERR_INIT_COMM_PROCESS = -1033;
	public const int FECOM_ERR_FLUSH_INPUT_BUFFER = -1034;
	public const int FECOM_ERR_FLUSH_OUTPUT_BUFFER = -1035;
	public const int FECOM_ERR_CHANGE_PORT_PARA = -1036;
	public const int FECOM_ERR_TRANSMIT_PROCESS = -1037;
	public const int FECOM_ERR_RECEIVE_NOISE_DATA = -1038;

	public const int FECOM_ERR_READ_PORT_PARA = -1039;
	// parameter errors
	public const int FECOM_ERR_UNKNOWN_PARAMETER = -1050;
	public const int FECOM_ERR_PARAMETER_OUT_OF_RANGE = -1051;
	public const int FECOM_ERR_ODD_PARAMETERSTRING = -1052;
	public const int FECOM_ERR_PORTNR_OUT_OF_RANGE = -1053;

	public const int FECOM_ERR_UNKNOWN_ERRORCODE = -1054;
	// receive buffer overflow

	public const int FECOM_ERR_OVL_RECBUF = -1070;
	// constants for dynamic load of library

	// miscellaneous functions
	public const int FECOM_GET_DLL_VERSION = 1000;
	public const int FECOM_GET_ERROR_TEXT = 1001;
	public const int FECOM_GET_LAST_ERROR = 1002;

	public const int FECOM_DETECT_PORT = 1003;
	// functions for event notification
	public const int FECOM_ADD_EVENT_HANDLER = 1010;

	public const int FECOM_DEL_EVENT_HANDLER = 1011;
	// port functions
	public const int FECOM_OPEN_PORT = 1020;
	public const int FECOM_CLOSE_PORT = 1021;
	public const int FECOM_GET_PORT_LIST = 1022;
	public const int FECOM_GET_PORT_PARA = 1023;
	public const int FECOM_SET_PORT_PARA = 1024;
	public const int FECOM_DO_PORT_CMD = 1025;

	public const int FECOM_GET_PORT_HND = 1026;
	// communication function
	public const int FECOM__TRANSCEIVE = 1030;
	public const int FECOM__TRANSMIT = 1031;

	public const int FECOM__RECEIVE = 1032;


	// constants for structure _FECOM_EVENT_INIT

	// defines for uiFlag in FECOM_EVENT_INIT
	public const int FECOM_THREAD_ID = 1;
	public const int FECOM_WND_HWND = 2;
	public const int FECOM_CALLBACK = 3;

	public const int FECOM_EVENT = 4;
	// defines for uiUse in FECOM_EVENT_INIT
	public const int FECOM_CTS_EVENT = 1;
	public const int FECOM_DCD_EVENT = 2;
	public const int FECOM_DSR_EVENT = 3;
	public const int FECOM_RTS_EVENT = 4;

	public const int FECOM_DTR_EVENT = 5;
		//' only for Windows CE (customized versions)
	public const int FECOM_PORT_CLOSED_EVENT = 20;
		//	' only for Windows CE (customized versions) 
	public const int FECOM_PORT_REOPEN_EVENT = 21;

	// #####################################################
	// FECOM structures
	// #####################################################
	// structure for transfering thread-IDs, message-handles or callbacks
	// structure for transfering callback functions
	public struct FECOM_EVENT_INIT
	{
		public int uiUse;
		public int uiMsg;
		public int uiFlag;
		public static DelgOnMessage Method;
		//Public Method As DelgComInfo
		//Public hwndWnd As Integer
	}

	public struct EventTest
	{
		public event SayHalloEventHandler SayHallo;
		public delegate void SayHalloEventHandler();
		public void DoEvent()
		{
			if (SayHallo != null) {
				SayHallo();
			}
		}
	}

	#endregion


	#region "FEISC constants"
	// #####################################################
	// FEISC constants
	// #####################################################

	// command bytes
	public const int FEISC_DESTROY = 0x18;
	public const int FEISC_HALT = 0x1a;
	public const int FEISC_RESET_QUIET_BIT = 0x1b;
	public const int FEISC_EAS_REQUEST = 0x1c;
	public const int FEISC_READ_BUFFER = 0x21;
	public const int FEISC_ADV_READ_BUFFER = 0x22;
	public const int FEISC_READ_BUFFER_INFO = 0x31;
	public const int FEISC_CLEAR_BUFFER = 0x32;
	public const int FEISC_INIT_BUFFER = 0x33;
	public const int FEISC_FORCE_NOTIFY_TRIGGER = 0x34;
	public const int FEISC_GET_BAUDRATE = 0x52;
	public const int FEISC_START_FLASH_LOADER = 0x55;
	public const int FEISC_START_FLASH_LOADER_EX = 0x55;
	public const int FEISC_CPU_RESET = 0x63;
	public const int FEISC_SYSTEM_RESET = 0x64;
	public const int FEISC_SOFT_VERSION = 0x65;
	public const int FEISC_READER_INFO = 0x66;
	public const int FEISC_CHANNEL_ANALYZE = 0x68;
	public const int FEISC_RF_RESET = 0x69;
	public const int FEISC_RF_ON_OFF = 0x6a;
	public const int FEISC_CENTRALIZED_RF_SYNC = 0x6b;
	public const int FEISC_SET_NOISE_LEVEL = 0x6c;
	public const int FEISC_GET_NOISE_LEVEL = 0x6d;
	public const int FEISC_READER_DIAGNOSE = 0x6e;
	public const int FEISC_ANTENNA_TUNING = 0x6f;
	public const int FEISC_SET_OUTPUT = 0x71;
	public const int FEISC_SET_OUTPUT_EX = 0x72;
	public const int FEISC_GET_INPUT = 0x74;
	public const int FEISC_ADJ_ANTENNA = 0x75;
	public const int FEISC_READ_CONF_BLOCK = 0x80;
	public const int FEISC_WRITE_CONF_BLOCK = 0x81;
	public const int FEISC_SAVE_CONF_BLOCK = 0x82;
	public const int FEISC_RESET_CONF_BLOCK = 0x83;
	public const int FEISC_SET_CONF_MEM_LOC = 0x84;
	public const int FEISC_SET_SYSTEM_TIMER = 0x85;
	public const int FEISC_GET_SYSTEM_TIMER = 0x86;
	public const int FEISC_SET_SYSTEM_DATE = 0x87;
	public const int FEISC_GET_SYSTEM_DATE = 0x88;
	public const int FEISC_READER_LOGIN = 0xa0;
	public const int FEISC_WRITE_MIFARE_KEYS = 0xa2;
	public const int FEISC_ISO_COMMAND = 0xb0;
	public const int FEISC_ISO_CUST_PROP_CMD = 0xb1;
	public const int FEISC_ISO_SP14443_COMMAND = 0xb2;
	public const int FEISC_EPC_COMMAND = 0xb3;
	public const int FEISC_EPC_UHF_COMMAND = 0xb4;
	public const int FEISC_COMMAND_QUEUE = 0xbc;
	public const int FEISC_ISO14443A_TRANSPARENT_CMD = 0xbd;
	public const int FEISC_ISO14443B_TRANSPARENT_CMD = 0xbe;
	public const int FEISC_ISO15693_TRANSPARENT_CMD = 0xbf;

	public const int FEISC_SAM_COMMAND = 0xc0;

	// error codes

	// common errors
	public const int FEISC_ERR_NEWREADER_FAILURE = -4000;
	public const int FEISC_ERR_EMPTY_LIST = -4001;
	public const int FEISC_ERR_POINTER_IS_NULL = -4002;
	public const int FEISC_ERR_NO_MORE_MEM = -4003;
	public const int FEISC_ERR_UNKNOWN_COMM_PORT = -4004;
	public const int FEISC_ERR_UNSUPPORTED_FUNCTION = -4005;
	public const int FEISC_ERR_NO_USB_SUPPORT = -4006;

	public const int FEISC_ERR_OLD_FECOM = -4007;
	// query errors

	public const int FEISC_ERR_NO_VALUE = -4010;
	// handle errors
	public const int FEISC_ERR_UNKNOWN_HND = -4020;
	public const int FEISC_ERR_HND_IS_NULL = -4021;
	public const int FEISC_ERR_HND_IS_NEGATIVE = -4022;
	public const int FEISC_ERR_NO_HND_FOUND = -4023;
	public const int FEISC_ERR_PORTHND_IS_NEGATIVE = -4024;

	public const int FEISC_ERR_HND_UNVALID = -4025;
	// communication errors
	public const int FEISC_ERR_PROTLEN = -4030;
	public const int FEISC_ERR_CHECKSUM = -4031;
	public const int FEISC_ERR_BUSY_TIMEOUT = -4032;
	public const int FEISC_ERR_UNKNOWN_STATUS = -4033;
	public const int FEISC_ERR_NO_RECPROTOCOL = -4034;
	public const int FEISC_ERR_CMD_BYTE = -4035;
	public const int FEISC_ERR_TRANSCEIVE = -4036;

	public const int FEISC_ERR_REC_BUS_ADR = -4037;
	// parameter errors
	public const int FEISC_ERR_UNKNOWN_PARAMETER = -4050;
	public const int FEISC_ERR_PARAMETER_OUT_OF_RANGE = -4051;
	public const int FEISC_ERR_ODD_PARAMETERSTRING = -4052;
	public const int FEISC_ERR_UNKNOWN_ERRORCODE = -4053;
	public const int FEISC_ERR_UNSUPPORTED_OPTION = -4054;

	public const int FEISC_ERR_UNKNOWN_EPC_TYPE = -4055;
	// plug-in errors
	public const int FEISC_ERR_NO_PLUGIN = -4060;
	public const int FEISC_ERR_PLUGIN_PRESENT = -4061;
	public const int FEISC_ERR_UNKNOWN_PLUGIN_ID = -4062;
	public const int FEISC_ERR_PI_BUILD_DATA = -4063;
	public const int FEISC_ERR_PI_BUILD_FRAME = -4064;
	public const int FEISC_ERR_PI_SPLIT_FRAME = -4065;

	public const int FEISC_ERR_PI_SPLIT_DATA = -4066;
	// communication data flow errors

	public const int FEISC_ERR_BUFFER_OVERFLOW = -4070;
	// task errors
	public const int FEISC_ERR_TASK_STILL_RUNNING = -4080;
	public const int FEISC_ERR_TASK_NOT_STARTED = -4081;
	public const int FEISC_ERR_TASK_TIMEOUT = -4082;
	public const int FEISC_ERR_TASK_SOCKET_INIT = -4083;
	public const int FEISC_ERR_TASK_BUSY = -4084;

	public const int FEISC_ERR_THREAD_CANCEL_ERROR = -4085;


	// defines for uiFlag in FEISC_EVENT_INIT
	public const int FEISC_THREAD_ID = 1;
	public const int FEISC_WND_HWND = 2;
	public const int FEISC_CALLBACK = 3;
	public const int FEISC_EVENT = 4;

	public const int FEISC_CALLBACK_2 = 5;
	// defines for uiUse in FEISC_EVENT_INIT
	public const int FEISC_PRT_EVENT = 1;
	public const int FEISC_SNDPRT_EVENT = 2;
	public const int FEISC_RECPRT_EVENT = 3;

	public const int FEISC_SCANNER_EVENT = 4;

	// defines for uiFlag in FEISC_TAS_INIT
	public const int FEISC_TASKCB_1 = 1;

	public const int FEISC_TASKCB_2 = 2;
	// defines for task identifier
	public const int FEISC_TASKID_FIRST_NEW_TAG = 1;
	public const int FEISC_TASKID_EVERY_NEW_TAG = 2;
	public const int FEISC_TASKID_NOTIFICATION = 3;
	public const int FEISC_TASKID_SAM_COMMAND = 4;

	public const int FEISC_TASKID_COMMAND_QUEUE = 5;
	// defines for channel types in FEISC_TASK_INIT
		// for open serial, usb, tcp channels
	public const int FEISC_TASK_CHANNEL_TYPE_AS_OPEN = 1;
		// for new tcp connection, established by host or reader
	public const int FEISC_TASK_CHANNEL_TYPE_NEW_TCP = 5;

	public struct FEISC_EVENT_INIT
	{
		public int uiUse;
		public int uiMsg;
		public int uiFlag;
		public DelgOnMessage Method;
	}

	// structure for transfering anything for an asynchronous task
	public struct FEISC_TASK_INIT
	{
		public byte[] pAny;
		public byte ucBusAdr;
		public int uiChannelType;
		public int iConnectByHost;
		public char[] cIPAdr;
		public int iPortNr;
		public int uiTimeout;
		public int uiFlag;
		public class dummy1
		{
			object cbFct1;
			object cbFct2;
		}
		public class dummy2
		{
			int iNotifyWithAck;
		}
	}

	#endregion

	#region "ISC Reader constans"
	// size of memories in bytes

		// memory for parameters in readers EEPROM
	public const int FEDM_ISC_MAX_EEDATA_MEM = 1024;
		// memory for parameters in readers RAM
	public const int FEDM_ISC_MAX_RAMDATA_MEM = 1024;
		// memory for temporary data
	public const int FEDM_ISC_MAX_TMPDATA_MEM = 4096;
	// size of memories in bytes
		// memory for parameters in readers EEPROM
	public const int FEDM_ISC_MAX_RFC_EEDATA_MEM = 1024;
		// memory for parameters in readers RAM
	public const int FEDM_ISC_MAX_RFC_RAMDATA_MEM = 1024;
		// memory for parameters in readers EEPROM
	public const int FEDM_ISC_MAX_ACC_EEDATA_MEM = 8192;
		// memory for parameters in readers RAM
	public const int FEDM_ISC_MAX_ACC_RAMDATA_MEM = 8192;

	// table types 
	// (uiTableID in functions GetTableData, SetTableData, FindTableIndex,
	//	GetTableSize, ResetTable)
	public const int FEDM_ISC_BRM_TABLE = 1;
	public const int FEDM_ISC_ISO_TABLE = 2;

	public const int FEDM_ISC_CAD_TABLE = 3;

	// access flags for the tables BRM and ISO
	// (uiDataID in functions GetTableData, SetTableData, FindTableIndex, ResetTable)
		// BRM and ISO
	public const int FEDM_ISC_DATA_TRTYPE = 0x8000001;
		// BRM and ISO
	public const int FEDM_ISC_DATA_SNR = 0x8000002;
		// BRM and ISO
	public const int FEDM_ISC_DATA_SNR_LEN = 0x8000003;
		// only ISO
	public const int FEDM_ISC_DATA_EPC = 0x8000004;
		// only ISO
	public const int FEDM_ISC_DATA_EPC_HEADER = 0x8000005;
		// only ISO
	public const int FEDM_ISC_DATA_EPC_DOMAIN = 0x8000006;
		// only ISO
	public const int FEDM_ISC_DATA_EPC_OBJECT = 0x8000007;
		// only ISO
	public const int FEDM_ISC_DATA_EPC_SNR = 0x8000008;
		// only ISO
	public const int FEDM_ISC_DATA_EPC_TYPE = 0x800000a;
		// only ISO
	public const int FEDM_ISC_DATA_AFI = 0x800000b;
		// only ISO
	public const int FEDM_ISC_DATA_DSFID = 0x800000c;
		// only ISO
	public const int FEDM_ISC_DATA_MEM_SIZE = 0x800000d;
		// only ISO
	public const int FEDM_ISC_DATA_IC_REF = 0x800000e;
		// only ISO14443A
	public const int FEDM_ISC_DATA_TRINFO = 0x800000f;
		// only ISO14443A
	public const int FEDM_ISC_DATA_OPTINFO = 0x8000010;
		// only ISO14443-4
	public const int FEDM_ISC_DATA_FSCI = 0x8000011;
		// only ISO14443-4
	public const int FEDM_ISC_DATA_FWI = 0x8000012;
		// only ISO14443-4
	public const int FEDM_ISC_DATA_DSI = 0x8000013;
		// only ISO14443-4
	public const int FEDM_ISC_DATA_DRI = 0x8000014;
		// only ISO14443-4
	public const int FEDM_ISC_DATA_NAD = 0x8000015;
		// only ISO14443-4
	public const int FEDM_ISC_DATA_CID = 0x8000016;
		// only ISO14443B
	public const int FEDM_ISC_DATA_PROTOINFO = 0x8000017;
		// BRM and ISO
	public const int FEDM_ISC_DATA_EPC_CL1_GEN2_PC = 0x8000018;
		// BRM and ISO
	public const int FEDM_ISC_DATA_RxDB = 0x4000001;
		// only ISO
	public const int FEDM_ISC_DATA_TxDB = 0x4000002;
		// only ISO
	public const int FEDM_ISC_DATA_SEC_STATUS = 0x4000003;
		// BRM and ISO
	public const int FEDM_ISC_DATA_BLOCK_SIZE = 0x4000004;
		// only ISO
	public const int FEDM_ISC_DATA_RxCB = 0x2000001;
		// only ISO
	public const int FEDM_ISC_DATA_TxCB = 0x2000002;
		// only BRM
	public const int FEDM_ISC_DATA_TIMER = 0x1000001;
		// only BRM
	public const int FEDM_ISC_DATA_DB_ADR = 0x1000002;
		// only BRM
	public const int FEDM_ISC_DATA_DBN = 0x1000003;
		// only BRM
	public const int FEDM_ISC_DATA_ANT_NR = 0x1000004;
		// only BRM
	public const int FEDM_ISC_DATA_DATE = 0x1000005;
		// only BRM
	public const int FEDM_ISC_DATA_INPUT = 0x1000006;
		// only BRM
	public const int FEDM_ISC_DATA_STATE = 0x1000007;
		// only ISO
	public const uint FEDM_ISC_DATA_IS_BLOCK_SIZE_SET = 0x80000001;
		// only ISO
	public const uint FEDM_ISC_DATA_IS_SELECTED = 0x80000002;
		// BRM and ISO
	public const uint FEDM_ISC_DATA_IS_SNR = 0x80000003;
		// only ISO
	public const uint FEDM_ISC_DATA_IS_EPC = 0x80000004;
		// only ISO
	public const uint FEDM_ISC_DATA_IS_AFI = 0x80000005;
		// only ISO
	public const uint FEDM_ISC_DATA_IS_DSFID = 0x80000006;
		// only ISO14443A
	public const uint FEDM_ISC_DATA_IS_TRINFO = 0x80000007;
		// only ISO
	public const uint FEDM_ISC_DATA_IS_SYSINFO = 0x80000008;
		// only BRM
	public const uint FEDM_ISC_DATA_IS_DB = 0x80000009;
		// only BRM
	public const uint FEDM_ISC_DATA_IS_TIMER = 0x8000000a;
		// only BRM
	public const uint FEDM_ISC_DATA_IS_ANT_NR = 0x8000000b;
		// only BRM
	public const uint FEDM_ISC_DATA_IS_DATE = 0x8000000c;
		// only ISO14443-4
	public const uint FEDM_ISC_DATA_IS_ISO14443_4_INFO = 0x8000000d;
		// only BRM
	public const uint FEDM_ISC_DATA_IS_INPUT = 0x8000000e;
		// for initialize all with ResetTable
	public const uint FEDM_ISC_DATA_ALL = 0xffff0000;
		// only ISO
	public const int FEDM_ISC_DATA_MEM_SIZE_LEN = 0x8000019;
		// only ISO
	public const int FEDM_ISC_DATA_CHIP_ID = 0x8000020;
		// only ISO
	public const int FEDM_ISC_DATA_VALUE = 0x4000005;


	// only for EPCglobal Class1, Generation2 Transponder
	// the user memory bank can be accessed with FEDM_ISC_DATA_RxDB and FEDM_ISC_DATA_TxDB
		// only ISO
	public const int FEDM_ISC_DATA_RxDB_EPC_BANK = 0x4001001;
		// only ISO
	public const int FEDM_ISC_DATA_TxDB_EPC_BANK = 0x4001002;
		// only ISO
	public const int FEDM_ISC_DATA_RxDB_TID_BANK = 0x4001003;
		// only ISO
	public const int FEDM_ISC_DATA_TxDB_TID_BANK = 0x4001004;
		// only ISO
	public const int FEDM_ISC_DATA_RxDB_RES_BANK = 0x4001005;
		// only ISO
	public const int FEDM_ISC_DATA_TxDB_RES_BANK = 0x4001006;


	// access flags for the table CAD
	// (uiDataID in functions GetTableData, ResetTable)
		// average power value
	public const int FEDM_ISC_DATA_POWER_AVG = 0x1;
		// peak power value
	public const int FEDM_ISC_DATA_POWER_PEAK = 0x2;
		// history record: allocation of channels
	public const int FEDM_ISC_DATA_HISTORY_ALLOC = 0x4;
		// history record: transmit channel
	public const int FEDM_ISC_DATA_HISTORY_TX = 0x8;
		// history record: no. of receive channels
	public const int FEDM_ISC_DATA_HISTORY_RX = 0x10;
		// miscellaneous data
	public const int FEDM_ISC_DATA_MISC = 0x20;


	// ISO-Command mode flags
	public const int FEDM_ISC_ISO_MODE_NONADR = 0x0;
	public const int FEDM_ISC_ISO_MODE_ADR = 0x1;
	public const int FEDM_ISC_ISO_MODE_SEL = 0x2;
	public const int FEDM_ISC_ISO_MODE_SEC = 0x8;
		// only for jewel transponder
	public const int FEDM_ISC_ISO_MODE_WR_NE = 0x8;
	public const int FEDM_ISC_ISO_MODE_UID_LF = 0x10;
		// only for ISO14443-Transponder and [= &HB0][= &H25] Select
	public const int FEDM_ISC_ISO_MODE_CINF = 0x20;
	public const int FEDM_ISC_ISO_MODE_EXT_ADR = 0x20;

	public const int FEDM_ISC_ISO_MODE_MORE = 0x80;
	// ISO-Command bank identifier for:
	// [0xB0][0x23] Read Multiple Blocks
	// [0xB0][0x24] Write Multiple Blocks
	public const int FEDM_ISC_ISO_BANK_RESERVED = 0x0;
	public const int FEDM_ISC_ISO_BANK_EPC_MEMORY = 0x1;
	public const int FEDM_ISC_ISO_BANK_TID_MEMORY = 0x2;

	public const int FEDM_ISC_ISO_BANK_USER_MEMORY = 0x3;


	// Manufacturer Code for [= &HB1] ISO-15693 Host Commands
	public const int FEDM_ISC_ISO_MFR_PHILIPS = 0x4;
	public const int FEDM_ISC_ISO_MFR_TI = 0x7;

	public const int FEDM_ISC_ISO_MFR_NXP = 0x4;

	// HF reader types
		// listed, but unsupported
	public const int FEDM_ISC_TYPE_ISCM01 = 30;
	public const int FEDM_ISC_TYPE_ISCM02 = 31;
		// listed, but unsupported
	public const int FEDM_ISC_TYPE_ISCLR100 = 40;
	public const int FEDM_ISC_TYPE_ISCLR200 = 41;
	public const int FEDM_ISC_TYPE_ISCLR2000 = 42;
	public const int FEDM_ISC_TYPE_ISCPRH101 = 60;
	public const int FEDM_ISC_TYPE_ISCPRH101_U = 61;
	public const int FEDM_ISC_TYPE_ISCPRHD102 = 62;
	public const int FEDM_ISC_TYPE_ISCPRHD102_X = 50;
	public const int FEDM_ISC_TYPE_ISCPRH102 = 63;
	public const int FEDM_ISC_TYPE_ISCPRH100_U = 71;
	public const int FEDM_ISC_TYPE_ISCPRH100 = 72;
	public const int FEDM_ISC_TYPE_ISCMR100_U = 73;
	public const int FEDM_ISC_TYPE_ISCMR100 = 74;
	public const int FEDM_ISC_TYPE_ISCPR100 = 74;
	public const int FEDM_ISC_TYPE_ISCMR200 = 75;
	public const int FEDM_ISC_TYPE_ISCMR101 = 76;
	public const int FEDM_ISC_TYPE_ISCMR101_U = 78;
	public const int FEDM_ISC_TYPE_CPRM02 = 80;
	public const int FEDM_ISC_TYPE_CPR02 = 81;
	public const int FEDM_ISC_TYPE_CPR40_XX_U = 82;
	public const int FEDM_ISC_TYPE_CPR40_XX = 83;
	public const int FEDM_ISC_TYPE_CPR04_U = 88;
	public const int FEDM_ISC_TYPE_CPRM02_U = 82;
	public const int FEDM_ISC_TYPE_CPR02_U = 83;
	public const int FEDM_ISC_TYPE_CPRM03 = 84;
	public const int FEDM_ISC_TYPE_CPR03 = 85;

	public const int FEDM_ISC_TYPE_CPR04 = 87;
	// UHF reader types
	public const int FEDM_ISC_TYPE_ISCMRU200 = 55;
	public const int FEDM_ISC_TYPE_ISCLRU1000 = 92;
	public const int FEDM_ISC_TYPE_ISCLRU2000 = 93;

	public const int FEDM_ISC_TYPE_ISCLRU3000 = 94;

	// name of readers
	public const string FEDM_ISC_NAME_ISCM01 = "ID ISC.M01";
	public const string FEDM_ISC_NAME_ISCM02 = "ID ISC.M02";
	public const string FEDM_ISC_NAME_ISCLR100 = "ID ISC.LR100";
	public const string FEDM_ISC_NAME_ISCLR200 = "ID ISC.LR200";
	public const string FEDM_ISC_NAME_ISCLR2000 = "ID ISC.LR2000";
	public const string FEDM_ISC_NAME_ISCLRM2000 = "ID ISC.LRM2000";
	public const string FEDM_ISC_NAME_ISCPRH101 = "ID ISC.PRH101";
	public const string FEDM_ISC_NAME_ISCPRH101_U = "ID ISC.PRH101-U";
	public const string FEDM_ISC_NAME_ISCPRH102 = "ID ISC.PRH102";
	public const string FEDM_ISC_NAME_ISCPRHD102 = "ID ISC.PRHD102";
	public const string FEDM_ISC_NAME_ISCPRHD102_X = "ID ISCUM02/PRHD102";
	public const string FEDM_ISC_NAME_ISCPRH100_U = "ID ISC.PRH100-U";
	public const string FEDM_ISC_NAME_ISCPRH100 = "ID ISC.PRH100";
	public const string FEDM_ISC_NAME_ISCMR100_U = "ID ISC.MR100-U";
	public const string FEDM_ISC_NAME_ISCMR100 = "ID ISC.MR100";
	public const string FEDM_ISC_NAME_ISCPR100 = "ID ISC.PR100";
	public const string FEDM_ISC_NAME_ISCMR200 = "ID ISC.MR200";
	public const string FEDM_ISC_NAME_ISCMR101 = "ID ISC.MR101";
	public const string FEDM_ISC_NAME_ISCMR101_U = "ID ISC.MR101-U";
	public const string FEDM_ISC_NAME_CPRM02_U = "ID CPR.M02-U";
	public const string FEDM_ISC_NAME_CPR02_U = "ID CPR.02-U";
	public const string FEDM_ISC_NAME_CPRM03 = "ID CPR.M03";
	public const string FEDM_ISC_NAME_CPR03 = "ID CPR.03";
	public const string FEDM_ISC_NAME_CPR04 = "ID CPR.04";
	public const string FEDM_ISC_NAME_CPRM02 = "ID CPR.M02";
	public const string FEDM_ISC_NAME_CPR02 = "ID CPR.02";
	public const string FEDM_ISC_NAME_CPR04_U = "ID CPR.04-USB";
	public const string FEDM_ISC_NAME_CPR40_XX_U = "ID CPR40.xx-U";

	public const string FEDM_ISC_NAME_CPR40_XX = "ID CPR40.xx";
		// UHF
	public const string FEDM_ISC_NAME_ISCMRU200 = "ID ISC.MRU200";
		// UHF
	public const string FEDM_ISC_NAME_ISCLRU1000 = "ID ISC.LRU1000";
		// UHF
	public const string FEDM_ISC_NAME_ISCLRMU1000 = "ID ISC.LRMU1000";
		// UHF
	public const string FEDM_ISC_NAME_ISCLRU2000 = "ID ISC.LRU2000";
		// UHF
	public const string FEDM_ISC_NAME_ISCLRMU2000 = "ID ISC.LRMU2000";
		// UHF
	public const string FEDM_ISC_NAME_ISCLRU3000 = "ID ISC.LRU3000";


	// HF transponder types
	public const int FEDM_ISC_TR_TYPE_ICODE1 = 0x0;
	public const int FEDM_ISC_TR_TYPE_TAGIT = 0x1;
	public const int FEDM_ISC_TR_TYPE_ISO15693 = 0x3;
	public const int FEDM_ISC_TR_TYPE_ISO14443A = 0x4;
	public const int FEDM_ISC_TR_TYPE_ISO14443B = 0x5;
	public const int FEDM_ISC_TR_TYPE_EPC = 0x6;
	public const int FEDM_ISC_TR_TYPE_ICODE_UID = 0x7;
	public const int FEDM_ISC_TR_TYPE_JEWEL = 0x8;

	public const int FEDM_ISC_TR_TYPE_0x64 = 0x64;
	// UHF transponder types
	public const int FEDM_ISC_TR_TYPE_ISO18000_6_A = 0x80;
	public const int FEDM_ISC_TR_TYPE_ISO18000_6_B = 0x81;
	public const int FEDM_ISC_TR_TYPE_EM4222 = 0x83;
	public const int FEDM_ISC_TR_TYPE_EPC_CLASS1_GEN2 = 0x84;
	public const int FEDM_ISC_TR_TYPE_EPC_CLASS0 = 0x88;
	public const int FEDM_ISC_TR_TYPE_EPC_CLASS1_GEN1 = 0x89;
	public const int FEDM_ISC_TR_TYPE_EPC_GEN2_HF = 0x9;
	public const int FEDM_ISC_TR_TYPE_STM_SR176 = 0xa;
	public const int FEDM_ISC_TR_TYPE_STM_SRIxx = 0xb;

	public const int FEDM_ISC_TR_TYPE_MCRF45x = 0xc;
	// HF transponder names
	public const string FEDM_ISC_TR_NAME_ICODE1 = "Philips I-Code1";
	public const string FEDM_ISC_TR_NAME_TAGIT = "Texas Instruments Tag-it HF";
	public const string FEDM_ISC_TR_NAME_ISO15693 = "ISO15693";
	public const string FEDM_ISC_TR_NAME_ISO14443A = "ISO14443-A";
	public const string FEDM_ISC_TR_NAME_ISO14443B = "ISO14443-B";
	public const string FEDM_ISC_TR_NAME_EPC = "EPC";
	public const string FEDM_ISC_TR_NAME_ICODE_UID = "I-CODE UID";
	public const string FEDM_ISC_TR_NAME_JEWEL = "Innovision Jewel";
	public const string FEDM_ISC_TR_NAME_0x64 = "ISO15693";
	public const string FEDM_ISC_TR_NAME_EPC_GEN2_HF = "EPC Gen 2 HF";
	public const string FEDM_ISC_TR_NAME_STM_SR176 = "STMicroelectronics SR176";
	public const string FEDM_ISC_TR_NAME_STM_SRIxx = "STMicroelectronics SRIxx";

	public const string FEDM_ISC_TR_NAME_MCRF45x = "Microchip MCRF45x";

	// UHF transponder names
	public const string  FEDM_ISC_TR_NAME_ISO18000_6_A = "ISO18000-6-A";
	public const string  FEDM_ISC_TR_NAME_ISO18000_6_B = "ISO18000-6-B";
	public const string  FEDM_ISC_TR_NAME_EM4222 = "EM4222";
	public const string  FEDM_ISC_TR_NAME_EPC_CLASS0 = "EPC Class 0";
	public const string  FEDM_ISC_TR_NAME_EPC_CLASS1_GEN1 = "EPC Class 1 Gen 1";

	public const string  FEDM_ISC_TR_NAME_EPC_CLASS1_GEN2 = "EPC Class 1 Gen 2";

	// EPC types (EPC = Electronic Product Code)
		// 96 bit EPC
	public const int FEDM_ISC_EPC_TYPE_1 = 0x0;
		// 64 bit EPC Type I
	public const int FEDM_ISC_EPC_TYPE_2 = 0x1;
		// 64 bit EPC Type II
	public const int FEDM_ISC_EPC_TYPE_3 = 0x2;
		// 64 bit EPC Type III
	public const int FEDM_ISC_EPC_TYPE_4 = 0x3;

	// name of readers in UNICODE
	//Public Const FEDM_ISC_NAME_ISCM01_UC	=		"ID ISC.M01"
	public const string FEDM_ISC_NAME_ISCM02_UC = "ID ISC.M02";
	//Public Const FEDM_ISC_NAME_ISCLR100_UC	=	"ID ISC.LR100"
	public const string FEDM_ISC_NAME_ISCLR200_UC = "ID ISC.LR200";
	public const string FEDM_ISC_NAME_ISCLR2000_UC = "ID ISC.LR2000";
	public const string FEDM_ISC_NAME_ISCLRM2000_UC = "ID ISC.LRM2000";
	public const string FEDM_ISC_NAME_ISCPRH101_UC = "ID ISC.PRH101";
	public const string FEDM_ISC_NAME_ISCPRH101_U_UC = "ID ISC.PRH101-U";
	public const string FEDM_ISC_NAME_ISCPRH102_UC = "ID ISC.PRH102";
	public const string FEDM_ISC_NAME_ISCPRHD102_UC = "ID ISC.PRHD102";
	public const string FEDM_ISC_NAME_ISCPRH100_U_UC = "ID ISC.PRH100-U";
	public const string FEDM_ISC_NAME_ISCPRH100_UC = "ID ISC.PRH100";
	public const string FEDM_ISC_NAME_ISCMR100_U_UC = "ID ISC.MR100-U";
	public const string FEDM_ISC_NAME_ISCMR100_UC = "ID ISC.MR100";
	public const string FEDM_ISC_NAME_ISCPR100_UC = "ID ISC.PR100";
	public const string FEDM_ISC_NAME_ISCMR200_UC = "ID ISC.MR200";
	public const string FEDM_ISC_NAME_ISCMR101_UC = "ID ISC.MR101";
	public const string FEDM_ISC_NAME_ISCMR101_U_UC = "ID ISC.MR101-U";
	public const string FEDM_ISC_NAME_CPRM02_UC = "ID CPR.M02";
	public const string FEDM_ISC_NAME_CPR02_UC = "ID CPR.02";
	public const string FEDM_ISC_NAME_CPR04_U_UC = "ID CPR.04-USB";
	public const string FEDM_ISC_NAME_CPR40_XX_U_UC = "ID CPR40-xx-U";
	public const string FEDM_ISC_NAME_CPR40_XX_UC = "ID CPR40-xx";
		// UHF
	public const string FEDM_ISC_NAME_ISCMRU200_UC = "ID ISC.MRU200";
		// UHF
	public const string FEDM_ISC_NAME_ISCLRU1000_UC = "ID ISC.LRU1000";
		// UHF
	public const string FEDM_ISC_NAME_ISCLRMU1000_UC = "ID ISC.LRMU1000";
		// UHF
	public const string FEDM_ISC_NAME_ISCLRU2000_UC = "ID ISC.LRU2000";
		// UHF
	public const string FEDM_ISC_NAME_ISCLRMU2000_UC = "ID ISC.LRMU2000";
		// UHF
	public const string FEDM_ISC_NAME_ISCLRU3000_UC = "ID ISC.LRU3000";


	#endregion

	#region "FECOM DLL"


	// #####################################################
	// FECOM DLL 
	// #####################################################

	[DllImport(dllName_com, EntryPoint = "FECOM_GetDLLVersion", SetLastError = true)]
	private static extern void FECOM_GetDLLVersion(byte[] cVersion);
	[DllImport(dllName_com, EntryPoint = "FECOM_OpenPort", SetLastError = true)]
	private static extern int FECOM_OpenPort(byte[] cPortNr);
	[DllImport(dllName_com, EntryPoint = "FECOM_ClosePort", SetLastError = true)]
	private static extern int FECOM_ClosePort(int iPortHnd);
	[DllImport(dllName_com, EntryPoint = "FECOM_SetPortPara", SetLastError = true)]
	private static extern int FECOM_SetPortPara(int iPortHnd, byte[] cPara, byte[] cValue);
	[DllImport(dllName_com, EntryPoint = "FECOM_DoPortCmd", SetLastError = true)]
	private static extern int FECOM_DoPortCmd(int iPortHnd, byte[] cCmd, byte[] cValue);
	[DllImport(dllName_com, EntryPoint = "FECOM_AddEventHandler", SetLastError = true)]
	private static extern int FECOM_AddEventHandler(int iPortHnd, ref FECOM_EVENT_INIT pInit);
    [DllImport(dllName_com, EntryPoint = "FECOM_GetErrorText", SetLastError = true)]
    private static extern int FECOM_GetErrorText(int iErrorCode, ref string cErrorText);
    [DllImport(dllName_com, EntryPoint = "FECOM_GetLastError", SetLastError = true)]
    private static extern int FECOM_GetLastError(int iPortHnd, ref int iErrorCode, ref string cErrorText);
    [DllImport(dllName_com, EntryPoint = "FECOM_DetectPort", SetLastError = true)]
    private static extern int FECOM_DetectPort(int iPortNr);
    [DllImport(dllName_com, EntryPoint = "FECOM_DelEventHandler", SetLastError = true)]
    private static extern int FECOM_DelEventHandler(int iPortHnd, ref FECOM_EVENT_INIT pInit);
    [DllImport(dllName_com, EntryPoint = "FECOM_GetPortList", SetLastError = true)]
    private static extern int FECOM_GetPortList(int iNext);
    [DllImport(dllName_com, EntryPoint = "FECOM_GetPortPara", SetLastError = true)]
    private static extern int FECOM_GetPortPara(int iPortHnd, ref string cPara, ref string cValue);
    [DllImport(dllName_com, EntryPoint = "FECOM_GetPortHnd", SetLastError = true)]
    private static extern int FECOM_GetPortHnd(ref string cPortNr);
    [DllImport(dllName_com, EntryPoint = "FECOM_Transceive", SetLastError = true)]
    private static extern int FECOM_Transceive(int iPortHnd, ref byte cSendProt, int iSendLen, ref byte cRecProt, int iRecLen);
    [DllImport(dllName_com, EntryPoint = "FECOM_Transmit",SetLastError = true)]
    private static extern int FECOM_Transmit(int iPortHnd, ref byte cSendProt, int iSendLen);
    [DllImport(dllName_com, EntryPoint = "FECOM_Receive",SetLastError = true)]
    private static extern int FECOM_Receive(int iPortHnd, ref byte cRecProt, int iRecLen);
	//Declare Function FECOM_AddEventHandler Lib "fecomce.dll" Alias "FECOM_AddEventHandler" (ByVal iPortHnd As Integer, ByRef pInit As FECOM_EVENT_INIT) As Integer
	#endregion

	#region "FEISC DLL"

	// #####################################################
	// FEISC declarate
	// #####################################################

	[DllImport(dllName_isc, EntryPoint = "FEISC_SetReaderPara", SetLastError = true)]
	private static extern int FEISC_SetReaderPara(int iReaderHnd, byte[] cPara, byte[] cValue);
	[DllImport(dllName_isc, EntryPoint = "FEISC_GetDLLVersion", SetLastError = true)]
	private static extern void FEISC_GetDLLVersion(byte[] cVersion);
	[DllImport(dllName_isc, EntryPoint = "FEISC_NewReader", SetLastError = true)]
	private static extern int FEISC_NewReader(int iPortHnd);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x66_ReaderInfo", SetLastError = true)]
	private static extern int FEISC_0x66_ReaderInfo(int iReaderHnd, byte cBusAdr, byte cMode, byte[] cVersion, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x65_SoftVersion", SetLastError = true)]
	private static extern int FEISC_0x65_SoftVersion(int iReaderHnd, byte cBusAdr, byte[] cVersion, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_DeleteReader", SetLastError = true)]
	private static extern int FEISC_DeleteReader(int iReaderHnd);
    
    [DllImport(dllName_isc, EntryPoint = "FEISC_0x80_ReadConfBlock", SetLastError = true)]
    private static extern int FEISC_0x80_ReadConfBlock(int iReaderHnd, byte cBusAdr, byte cConfAdr,  byte[] cConfBlock, int iDataFormat);
	
    [DllImport(dllName_isc, EntryPoint = "FEISC_0x81_WriteConfBlock", SetLastError = true)]
	private static extern int FEISC_0x81_WriteConfBlock(int iReaderHnd, byte cBusAdr, byte cConfAdr, byte[] cConfBlock, int iDataFormat);
	
    [DllImport(dllName_isc, EntryPoint = "FEISC_0x82_SaveConfBlock", SetLastError = true)]
	private static extern int FEISC_0x82_SaveConfBlock(int iReaderHnd, byte cBusAdr, byte cConfAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x69_RFReset", SetLastError = true)]
	private static extern int FEISC_0x69_RFReset(int iReaderHnd, byte cBusAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xB0_ISOCmd", SetLastError = true)]
	private static extern int FEISC_0xB0_ISOCmd(int iReaderHnd, byte cBusAdr, byte[] cReqData, int iReqLen, byte[] cRspData, ref int iRspLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xB2_ISOCmd", SetLastError = true)]
	private static extern int FEISC_0xB2_ISOCmd(int iReaderHnd, byte cBusAdr, byte[] cReqData, int iReqLen, byte[] cRspData, ref int iRspLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_AddEventHandler", SetLastError = true)]
	private static extern int FEISC_AddEventHandler(int iReaderHnd, ref FEISC_EVENT_INIT pInit);
	[DllImport(dllName_isc, EntryPoint = "FEISC_GetErrorText", SetLastError = true)]
	private static extern int FEISC_GetErrorText(int iErrorCode, byte[] cErrorText);
	[DllImport(dllName_isc, EntryPoint = "FEISC_GetStatusText", SetLastError = true)]
	private static extern int FEISC_GetStatusText(byte ucStatus, ref char cStatusText);
	[DllImport(dllName_isc, EntryPoint = "FEISC_DelEventHandler", SetLastError = true)]
	private static extern int FEISC_DelEventHandler(int iReaderHnd, ref FEISC_EVENT_INIT pInit);
	[DllImport(dllName_isc, EntryPoint = "FEISC_SetCbPtr_ProtStr", SetLastError = true)]
	private static extern void FEISC_SetCbPtr_ProtStr(byte[] cbPtr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_GetReaderList", SetLastError = true)]
	private static extern int FEISC_GetReaderList(int iNext);
	[DllImport(dllName_isc, EntryPoint = "FEISC_GetReaderPara", SetLastError = true)]
	private static extern int FEISC_GetReaderPara(int iReaderHnd, ref char cPara, ref char cValue);
	[DllImport(dllName_isc, EntryPoint = "FEISC_InstallPlugIn", SetLastError = true)]
	private static extern int FEISC_InstallPlugIn(int iReaderHnd, int iPlugInID, byte[] pPlugIn);
	[DllImport(dllName_isc, EntryPoint = "FEISC_RemovePlugIn", SetLastError = true)]
	private static extern int FEISC_RemovePlugIn(int iReaderHnd, int iPlugInID);
	[DllImport(dllName_isc, EntryPoint = "FEISC_StartAsyncTask", SetLastError = true)]
	private static extern int FEISC_StartAsyncTask(int iReaderHnd, int iTaskID, ref FEISC_TASK_INIT pInit, byte[] pInput);
	[DllImport(dllName_isc, EntryPoint = "FEISC_CancelAsyncTask", SetLastError = true)]
	private static extern int FEISC_CancelAsyncTask(int iReaderHnd);
	[DllImport(dllName_isc, EntryPoint = "FEISC_TriggerAsyncTask", SetLastError = true)]
	private static extern int FEISC_TriggerAsyncTask(int iReaderHnd);
	[DllImport(dllName_isc, EntryPoint = "FEISC_BuildSendProtocol", SetLastError = true)]
	private static extern int FEISC_BuildSendProtocol(int iReaderHnd, byte cBusAdr, byte cCmdByte, ref byte cSendData, int iDataLen, ref byte cSendProt, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_BuildRecProtocol", SetLastError = true)]
	private static extern int FEISC_BuildRecProtocol(int iReaderHnd, byte cBusAdr, byte cCmdByte, byte cStatus, ref byte cRecData, int iDataLen, ref byte cRecProt, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_SplitSendProtocol", SetLastError = true)]
	private static extern int FEISC_SplitSendProtocol(int iReaderHnd, ref byte cSendProt, int iSendLen, ref byte cBusAdr, ref byte cCmdByte, ref byte cSendData, ref int iDataLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_SplitRecProtocol", SetLastError = true)]
	private static extern int FEISC_SplitRecProtocol(int iReaderHnd, ref byte cRecProt, int iRecLen, ref byte cBusAdr, ref byte cCmdByte, ref byte cRecData, ref int iDataLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_Conv2StdProtocol", SetLastError = true)]
	private static extern int FEISC_Conv2StdProtocol(ref byte cProt, int iLen);
	[DllImport(dllName_isc, EntryPoint = "FEISC_Conv2AdvProtocol", SetLastError = true)]
	private static extern int FEISC_Conv2AdvProtocol(ref byte cProt, int iLen);
	[DllImport(dllName_isc, EntryPoint = "FEISC_GetLastSendProt", SetLastError = true)]
	private static extern int FEISC_GetLastSendProt(int iReaderHnd, ref byte cSendProt, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_GetLastRecProt", SetLastError = true)]
	private static extern int FEISC_GetLastRecProt(int iReaderHnd, ref byte cRecProt, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_GetLastState", SetLastError = true)]
	private static extern int FEISC_GetLastState(int iReaderHnd, ref char cStateText);
	[DllImport(dllName_isc, EntryPoint = "FEISC_GetLastRecProtLen", SetLastError = true)]
	private static extern int FEISC_GetLastRecProtLen(int iReaderHnd);
	[DllImport(dllName_isc, EntryPoint = "FEISC_GetLastError", SetLastError = true)]
	private static extern int FEISC_GetLastError(int iReaderHnd, ref int iErrorCode, ref char cErrorText);
	[DllImport(dllName_isc, EntryPoint = "FEISC_SendTransparent", SetLastError = true)]
	private static extern int FEISC_SendTransparent(int iReaderHnd, ref byte cSendProt, int iSendLen, ref byte cRecProt, int iMaxRecLen, int iCheckSum, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_Transmit", SetLastError = true)]
	private static extern int FEISC_Transmit(int iReaderHnd, ref byte cSendProt, int iSendLen, int iCheckSum, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_Receive", SetLastError = true)]
	private static extern int FEISC_Receive(int iReaderHnd, ref byte cRecProt, int iMaxRecLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x18_Destroy", SetLastError = true)]
	private static extern int FEISC_0x18_Destroy(int iReaderHnd, byte cBusAdr, byte ucMode, ref byte ucEPC, ref byte ucPW);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x1A_Halt", SetLastError = true)]
	private static extern int FEISC_0x1A_Halt(int iReaderHnd, byte cBusAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x1B_ResetQuietBit", SetLastError = true)]
	private static extern int FEISC_0x1B_ResetQuietBit(int iReaderHnd, byte cBusAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x1C_EASRequest", SetLastError = true)]
	private static extern int FEISC_0x1C_EASRequest(int iReaderHnd, byte cBusAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x21_ReadBuffer", SetLastError = true)]
	private static extern int FEISC_0x21_ReadBuffer(int iReaderHnd, byte cBusAdr, byte cSets, ref byte cTrData, ref byte cRecSets, ref byte cRecDataSets, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x22_ReadBuffer", SetLastError = true)]
	private static extern int FEISC_0x22_ReadBuffer(int iReaderHnd, byte cBusAdr, int iSets, ref byte cTrData, ref int iRecSets, ref byte cRecDataSets, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x31_ReadDataBufferInfo", SetLastError = true)]
	private static extern int FEISC_0x31_ReadDataBufferInfo(int iReaderHnd, byte cBusAdr, ref byte cTabSize, ref byte cTabStart, ref byte cTabLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x32_ClearDataBuffer", SetLastError = true)]
	private static extern int FEISC_0x32_ClearDataBuffer(int iReaderHnd, byte cBusAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x33_InitBuffer", SetLastError = true)]
	private static extern int FEISC_0x33_InitBuffer(int iReaderHnd, byte cBusAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x34_ForceNotifyTrigger", SetLastError = true)]
	private static extern int FEISC_0x34_ForceNotifyTrigger(int iReaderHnd, byte cBusAdr, byte cMode);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x52_GetBaud", SetLastError = true)]
	private static extern int FEISC_0x52_GetBaud(int iReaderHnd, byte cBusAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x55_StartFlashLoader", SetLastError = true)]
	private static extern int FEISC_0x55_StartFlashLoader(int iReaderHnd);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x55_StartFlashLoaderEx", SetLastError = true)]
	private static extern int FEISC_0x55_StartFlashLoaderEx(int iReaderHnd, byte cBusAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x63_CPUReset", SetLastError = true)]
	private static extern int FEISC_0x63_CPUReset(int iReaderHnd, byte cBusAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x64_SystemReset", SetLastError = true)]
	private static extern int FEISC_0x64_SystemReset(int iReaderHnd, byte cBusAdr, byte cMode);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x68_ChannelAnalyze", SetLastError = true)]
	private static extern int FEISC_0x68_ChannelAnalyze(int iReaderHnd, byte cBusAdr, byte cMode, byte cRes1, byte cRes2, byte cRes3, int iRes4, ref int nData);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x6A_RFOnOff", SetLastError = true)]
	private static extern int FEISC_0x6A_RFOnOff(int iReaderHnd, byte cBusAdr, byte cRF);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x6B_InitNoiseThreshold", SetLastError = true)]
	private static extern int FEISC_0x6B_InitNoiseThreshold(int iReaderHnd, byte cBusAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x6B_CentralizedRFSync", SetLastError = true)]
	private static extern int FEISC_0x6B_CentralizedRFSync(int iReaderHnd, byte cBusAdr, byte cMode, byte cTxChannel, int iTxPeriod, byte cRes1, byte cRes2);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x6C_SetNoiseLevel", SetLastError = true)]
	private static extern int FEISC_0x6C_SetNoiseLevel(int iReaderHnd, byte cBusAdr, ref byte cLevel, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x6D_GetNoiseLevel", SetLastError = true)]
	private static extern int FEISC_0x6D_GetNoiseLevel(int iReaderHnd, byte cBusAdr, ref byte cLevel, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x6E_RdDiag", SetLastError = true)]
	private static extern int FEISC_0x6E_RdDiag(int iReaderHnd, byte cBusAdr, byte cMode, ref byte cData);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x6F_AntennaTuning", SetLastError = true)]
	private static extern int FEISC_0x6F_AntennaTuning(int iReaderHnd, byte cBusAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x71_SetOutput", SetLastError = true)]
	private static extern int FEISC_0x71_SetOutput(int iReaderHnd, byte cBusAdr, int iOS, int iOSF, int iOSTime, int iOutTime);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x72_SetOutput", SetLastError = true)]
	private static extern int FEISC_0x72_SetOutput(int iReaderHnd, byte cBusAdr, byte cMode, byte cOutN, ref byte pRecords);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x74_ReadInput", SetLastError = true)]
	private static extern int FEISC_0x74_ReadInput(int iReaderHnd, byte cBusAdr, ref byte cInput);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x75_AdjAntenna", SetLastError = true)]
	private static extern int FEISC_0x75_AdjAntenna(int iReaderHnd, byte cBusAdr, ref byte cValue, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x83_ResetConfBlock", SetLastError = true)]
	private static extern int FEISC_0x83_ResetConfBlock(int iReaderHnd, byte cBusAdr, byte cConfAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x84_SetCFGMemLoc", SetLastError = true)]
	private static extern int FEISC_0x84_SetCFGMemLoc(int iReaderHnd, byte cBusAdr, byte cMemAdr);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x85_SetSysTimer", SetLastError = true)]
	private static extern int FEISC_0x85_SetSysTimer(int iReaderHnd, byte cBusAdr, ref byte cTime, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x86_GetSysTimer", SetLastError = true)]
	private static extern int FEISC_0x86_GetSysTimer(int iReaderHnd, byte cBusAdr, ref byte cTime, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x87_SetSystemDate", SetLastError = true)]
	private static extern int FEISC_0x87_SetSystemDate(int iReaderHnd, byte cBusAdr, byte cCentury, byte cYear, byte cMonth, byte cDay, byte cTimezone, byte cHour, byte cMinute, int iMilliSecond);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0x88_GetSystemDate", SetLastError = true)]
	private static extern int FEISC_0x88_GetSystemDate(int iReaderHnd, byte cBusAdr, ref byte cCentury, ref byte cYear, ref byte cMonth, ref byte cDay, ref byte cTimezone, ref byte cHour, ref byte cMinute, ref int iMilliSecond);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xA0_RdLogin", SetLastError = true)]
	private static extern int FEISC_0xA0_RdLogin(int iReaderHnd, byte cBusAdr, ref byte cRd_PW, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xA2_WriteMifareKeys", SetLastError = true)]
	private static extern int FEISC_0xA2_WriteMifareKeys(int iReaderHnd, byte cBusAdr, byte c_Type, byte cAdr, ref byte cKey, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xB1_ISOCust", SetLastError = true)]
	private static extern int FEISC_0xB1_ISOCust(int iReaderHnd, byte cBusAdr, byte cMfr, ref byte cReqData, int iReqLen, ref byte cRspData, ref int iRspLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xB3_EPCCmd", SetLastError = true)]
	private static extern int FEISC_0xB3_EPCCmd(int iReaderHnd, byte cBusAdr, ref byte cReqData, int iReqLen, ref byte cRspData, ref int iRspLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xB4_EPC_UHF_Cmd", SetLastError = true)]
	private static extern int FEISC_0xB4_EPC_UHF_Cmd(int iReaderHnd, byte cBusAdr, byte cMfr, ref byte cReqData, int iReqLen, ref byte cRspData, ref int iRspLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xBC_CmdQueue", SetLastError = true)]
	private static extern int FEISC_0xBC_CmdQueue(int iReaderHnd, int iMode, int iCmdNo, ref byte cCmdQueue, int iCmdQueueLen, ref FEISC_TASK_INIT pInit);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xBD_ISOTranspCmd", SetLastError = true)]
	private static extern int FEISC_0xBD_ISOTranspCmd(int iReaderHnd, byte cBusAdr, int iMode, int iRspLength, ref byte cReqData, int iReqLen, ref byte cRspData, ref int iRspLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xBE_ISOTranspCmd", SetLastError = true)]
	private static extern int FEISC_0xBE_ISOTranspCmd(int iReaderHnd, byte cBusAdr, int iMode, int iRspLength, ref byte cReqData, int iReqLen, ref byte cRspData, ref int iRspLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xBF_ISOTranspCmd", SetLastError = true)]
	private static extern int FEISC_0xBF_ISOTranspCmd(int iReaderHnd, byte cBusAdr, int iMode, int iRspLength, ref byte cReqData, int iReqLen, ref byte cRspData, ref int iRspLen, int iDataFormat);
	[DllImport(dllName_isc, EntryPoint = "FEISC_0xC0_SAMCmd", SetLastError = true)]
	private static extern int FEISC_0xC0_SAMCmd(int iReaderHnd, int iSlot, ref byte cReqData, int iReqLen, ref FEISC_TASK_INIT pInit);


	//Declare Function FEISC_AddEventHandler Lib "feiscce.dll" Alias "FEISC_AddEventHandler" (ByVal iReaderHnd As Integer, ByRef pInit As FEISC_EVENT_INIT) As Integer
	#endregion

	#region "Reader Vaiablen"

    private const string dllName_com = "fecomce_mc9090.dll";
	private const string dllName_usb = "feisusb.dll";  // not in use // its MC95...
    private const string dllName_isc = "feiscce_mc9090.dll";
	//Private Const dllName_com As String = "fecomce.dll"
	//Private Const dllName_isc As String = "feiscce.dll"
		//Data of last Read operation
	private byte[] Read_Array;
		//Data of last Read operation
	private byte[] Write_Array;
		// Confog array for ISO Scan or ISO Host Mode
	private byte[] Config_Array;
		//Data for the ReaderInfo
	private byte[] Info_Array;
	private byte[] My_ComArray;
	public string[] InfoReader;
	private byte[] Error_Array;
	private byte[] cReqData;
	private byte[] cRspData;
	private byte[] UID_Array;
	private byte[] UID_Array24;

	private byte[] Value_Array;
	private byte[] SelMifare_Array;
	private byte[] Key_Array;
	private byte[] ReadMi_Array;

	private byte[] WriteMi_Array;
	private int iReaderHnd;
	private int iPortHnd;
	private int ideviceID;
	private byte iDataType = 0;
	private int iRspLen;
	private int iReqLen;
	private byte cBusAdr = 255;

	private byte cMode = 0;
	private string sBaud = "38400";
	private string sFrame = "8E1";
	private string sTimeout = "1000";
	private int R_Result;
	public string UIDNr = "";
	public string BlockDataHex = "";

	public string BlockDataAScII = "";
	public string TagTyp;
	public string COMVersion;
	public string ISCVersion;
	public string ReaderInfo;
	public string SoftwareInfo;
	private string Info_Text;
	public bool IsActive = false;
	public bool IsSascha = false;
	public FECOM_EVENT_INIT m_Init;
	public bool LastCTS;
    
	public string MifareKey;
    public int RFPower;
    #endregion

    #region "delegate test"
    public delegate void DelgOnMessage(IntPtr wParam, IntPtr lParam);
	public delegate void DelgComInfo(IntPtr wParam, IntPtr lParam);
	#endregion

	#region "Events"
	// These events allow the program using this class to react to Comm Port
	//   events.
	//    Public Event GetReaderText(ByVal Source As RFIDFeig, ByVal Info_Text As String)

	public event GetReaderTextEventHandler GetReaderText;
	public delegate void GetReaderTextEventHandler(string Info_Text);

	public event GetBlockDataEventHandler GetBlockData;
	public delegate void GetBlockDataEventHandler(int BlockNr, string BlockData);

	public event IsReaderDownEventHandler IsReaderDown;
	public delegate void IsReaderDownEventHandler(bool IsDown);


	#endregion

	#region "Add Events"

	#endregion

    #region "utility"

    public byte[] stringToByteArray(string str)
	{
		//---e.g. "abcdefg" to {a,b,c,d,e,f,g}
		char[] s = null;
		s = str.ToCharArray();
		byte[] b = new byte[s.Length];
		int i = 0;
		for (i = 0; i <= s.Length - 1; i++) {
			b[i] = Convert.ToByte(s[i]);
		}
		return b;
	}


    public string byteArrayToString(byte[] b)
    {
        //---e.g. {a,b,c,d,e,f,g} to "abcdefg" 
        string str = "";
        System.Text.ASCIIEncoding enc = default(System.Text.ASCIIEncoding);
        enc = new System.Text.ASCIIEncoding();
        str = enc.GetString(b, 0, b.Length);
        return str;
    }

	public void ClearStringArray(ref string[] src)
	{
		int i = 0;
		for (i = src.GetLowerBound(0); i <= src.GetUpperBound(0); i++) {
			src[i] = "";
		}
	}

	public void ClearCharArray(ref char[] src)
	{
		int i = 0;
		for (i = src.GetLowerBound(0); i <= src.GetUpperBound(0); i++) {
			src[i] = '\0';
		}
	}

	public void ClearArray(ref byte[] src)
	{
		int i = 0;
		for (i = src.GetLowerBound(0); i <= src.GetUpperBound(0); i++) {
			src[i] = 0;
		}
	}


    public string GetByteDataBufferToHex(byte[] Src, int BStart, int BStop)
    {
        string functionReturnValue = "";
        int i = 0;
        string tmp = string.Empty;
        for (i = BStart; i <= BStop; i++)
        {
            tmp = "";
            tmp = Src[i].ToString("X");
            if (tmp.Length == 1)
            {
                tmp = "0" + tmp;
            }
            functionReturnValue += tmp;
        }
        return functionReturnValue;
    }

	public string GetInverted(string Data)
	{
        string functionReturnValue = "";
		int i = 0;
		functionReturnValue = "";
		for (i = Data.Length - 1; i >= 0; i += -1) {
			functionReturnValue = functionReturnValue + Data[i];
		}
		return functionReturnValue;
	}

    public string GetByteDataBufferToHexInverted(byte[] Src, int BStart, int BStop)
    {
        string functionReturnValue = "";
        int i = 0;
        string tmp = string.Empty;
        functionReturnValue = "";
        for (i = BStop; i >= BStart; i += -1)
        {
            tmp = "";
            tmp = Src[i].ToString("X");
            if (tmp.Length == 1)
            {
                tmp = "0" + tmp;
            }
            functionReturnValue += tmp;
        }
        return functionReturnValue;
    }


    public string GetByteBufferToHex(byte[] Src, int DataLen)
    {
        string functionReturnValue = "";
        int i = 0;
        string tmp = string.Empty;
        functionReturnValue = "";
        for (i = 0; i <= DataLen - 1; i++)
        {
            tmp = "";
            tmp = Src[i].ToString("X");
            if (tmp.Length == 1)
            {
                tmp = "0" + tmp;
            }
            functionReturnValue += tmp;
        }
        return functionReturnValue;
    }

    public string ASCIIToHex(string Input)
    {
        System.Text.StringBuilder sb = new System.Text.StringBuilder();
        foreach (char c in Input)
        {
            sb.Append(Convert.ToInt32(c).ToString("X2"));
        }
        return sb.ToString();
    }

    public string HexToASCII(string Input)
    {
        int i = 0;
        System.Text.StringBuilder sb = new System.Text.StringBuilder();
        for (i = 0; i <= Input.Length - 2; i += 2)
        {
            sb.Append(Convert.ToChar(Convert.ToByte(Input.Substring(i, 2), 16))).ToString();
        }
        return sb.ToString();
    }

    public string ByteToASCII(byte[] arr)
    {
        System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
        return enc.GetString(arr, 0, arr.Length);
    }

    public int HexToInt(string Input)
    {
        return Convert.ToInt32(Input, 16);
    }

    public string ByteToHex(byte[] src)
    {
        string functionReturnValue = "";
        int i = 0;
        string tmp = "";
        functionReturnValue = "";
        for (i = src.GetLowerBound(0); i <= src.GetUpperBound(0); i++)
        {
            tmp = "";
            tmp = src[i].ToString("X2");
            if (tmp.Length == 1)
            {
                tmp = "0" + tmp;
            }
            functionReturnValue += tmp;
        }
        return functionReturnValue;
    }


    public string SByteToASCII(sbyte[] Src)
    {
        string Result = "";
        int i = 0;
        char tmp = '\0';
        for (i = Src.GetLowerBound(0); i <= Src.GetUpperBound(0); i++)
        {
            tmp = '\0';
            tmp = Convert.ToChar(Src[i]);
            Result += tmp;
        }
        return Result;
    }

    public void ASCIIToByte(string src, ref byte[] des)
    {
        int i = 0;
        for (i = 1; i <= src.Length; i++)
        {
            des[i - 1] = (byte)Convert.ToChar(src.Substring(i, 1));
        }
    }

    public byte[] GetDynASCIIByte(string src)
    {
        byte[] functionReturnValue = null;
        int i = 0;
        byte[] des = null;
        functionReturnValue = new byte[src.Length];
        des = new byte[src.Length];
        for (i = 1; i <= src.Length; i++)
        {
            des[i - 1] = (byte)Convert.ToChar(src.Substring(i, 1));
        }
        functionReturnValue = des;
        return functionReturnValue;
    }

    public byte[] GetASCIIByte(string src)
    {
        int i = 0;
        byte[] des = null;
        des = new byte[256];
        for (i = 0; i <= src.Length - 1; i++)
        {
            des[i] = (byte)Convert.ToChar(src.Substring(i, 1));
        }
        return des;
    }

    public char[] GetASCIIChar(string src)
    {
        char[] Result = null;
        Result = new char[src.Length - 1];
        Result = src.ToCharArray();
        return Result;
    }

    #endregion

    #region "RTS/CTS/DTR/DSR/DCD"

    public string GetRTS()
	{
        string functionReturnValue = string.Empty; 
		functionReturnValue = "";
		R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetRTS"), Value_Array);
		if (R_Result == 0) {
			functionReturnValue = ByteToASCII(Value_Array).Trim();
		}
		return functionReturnValue;
	}

    public bool SetRTS(string cmd)
    {
        R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("SetRTS"), GetASCIIByte(cmd));
        return R_Result == 0;
    }

	public bool SetDTR(string cmd)
	{
		R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("SetDTR"), GetASCIIByte(cmd));
		return R_Result == 0;
	}

	public string GetDTR()
	{
        string functionReturnValue = string.Empty;
		functionReturnValue = "";
		R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetDTR"), Value_Array);
		if (R_Result == 0) {
			functionReturnValue = ByteToASCII(Value_Array).Trim();
		}
		return functionReturnValue;
	}


	public string GetCTS()
	{
        string functionReturnValue = string.Empty;
		functionReturnValue = "";
		R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetCTS"), Value_Array);
		if (R_Result == 0) {
			//GetCTS = Trim(ByteToASCII(Value_Array))
			functionReturnValue = System.Text.Encoding.Default.GetString(Value_Array, 0, Value_Array.Length);
		}
		return functionReturnValue;
	}

	public string GetDSR()
	{
        string functionReturnValue = string.Empty;
		functionReturnValue = "";
		R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetDSR"), Value_Array);
		if (R_Result == 0) {
			functionReturnValue = ByteToASCII(Value_Array).Trim();
		}
		return functionReturnValue;
	}

	public string GetDCD()
	{
        string functionReturnValue = string.Empty;
		functionReturnValue = "";
		R_Result = FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetDCD"), Value_Array);
		if (R_Result == 0) {
			functionReturnValue = ByteToASCII(Value_Array).Trim();
		}
		return functionReturnValue;
    }

    public bool NotCTS()
    {
        bool functionReturnValue = false;
        string tmp = string.Empty;
        functionReturnValue = false;
        FECOM_DoPortCmd(iReaderHnd, GetASCIIByte("GetCTS"), Value_Array);
        tmp = System.Text.Encoding.Default.GetString(Value_Array, 0, Value_Array.Length);
        functionReturnValue = (tmp.IndexOf("OFF") == -1);
        if (IsReaderDown != null)
        {
            IsReaderDown(functionReturnValue);
        }
        return functionReturnValue;
    }

    public bool CheckReaderCTS()
    {
        bool Result = false;
        int i = 0;
        LastCTS = false;
        for (i = 1; i <= 3; i++)
        {
            System.Windows.Forms.Application.DoEvents();
            if (NotCTS())
            {
                SetOn();
                Result = false;
            }
            else
            {
                Result = true;
            }
            if (Result)
            {
                break; // TODO: might not be correct. Was : Exit For
            }
        }
        LastCTS = Result;
        return Result;
    }

    public bool SetOn()
    {
        bool R1 = false;
        bool R2 = false;
        R1 = (FECOM_DoPortCmd(iPortHnd, GetASCIIByte("SetDTR"), GetASCIIByte("ON")) == 1);
        R2 = (FECOM_DoPortCmd(iPortHnd, GetASCIIByte("SetRTS"), GetASCIIByte("ON")) == 1);
        return (R1 == true) & (R2 == true);
    }


    #endregion

    public void OnConnect(IntPtr wParam, IntPtr lParam)
	{
		//MessageBox.Show("Hallo");

    }

    #region "Reader function/void"

    public int IsUSB()
	{
		return FEUSB_IsDevicePresent(iPortHnd);
	}

    public bool InitializeUSB()
    {
        bool functionReturnValue = false;
        FEUSB_SCANSEARCH pSearchOp1 = new FEUSB_SCANSEARCH();
        functionReturnValue = false;
        IsActive = false;
        iReaderHnd = -1;
        iPortHnd = -1;
        iReaderHnd = FEISC_NewReader(0);
        if (iReaderHnd > 0)
        {
            if (GetReaderText != null)
            {
                GetReaderText("iReaderHnd = OK");
            }
            FEUSB_ClearScanList();
            iPortHnd = FEUSB_ScanAndOpen(FEUSB_SCAN_FIRST, ref pSearchOp1);
            if (iPortHnd > 0)
            {
                if (GetReaderText != null)
                {
                    GetReaderText("iPortHnd = OK");
                }
                R_Result = FEISC_SetReaderPara(iReaderHnd, GetASCIIByte("PortHnd"), GetASCIIByte(iPortHnd.ToString()));
                functionReturnValue = true;
            }
            else
            {
                GetFeigErrorTextUSB(iPortHnd);
            }
        }
        IsActive = functionReturnValue;
        if (!IsActive)
        {
            ReaderUnload();
        }
        return functionReturnValue;
    }


    /*	public bool InitUSB_Old_Test()
	{
		bool functionReturnValue = false;
		int Back = 0;
		//Dim oSearch As New FEUSB_SCANSEARCH_BYTE
		byte[] sDeviceID = new byte[16];
		string[] strDeviceID = new string[16];
		long nDeviceID = 0;
		string mystring = null;
		FEUSB_SCANSEARCH_BYTE pSearchOpt = new FEUSB_SCANSEARCH_BYTE();
		pSearchOpt.iMask = 0;
		 // ERROR: Not supported in C#: ReDimStatement

		 // ERROR: Not supported in C#: ReDimStatement

		 // ERROR: Not supported in C#: ReDimStatement

		 // ERROR: Not supported in C#: ReDimStatement


		functionReturnValue = false;

		FEUSB_ClearScanList();
		// clear the device scan list

		//Back = FEUSB_Scan(FEUSB_SCAN_ALL, pSearchOpt);
		// scan USB for devices

		// did we find some devices ?
		if (Back < 0) {
			// no
			//Interaction.MsgBox("No RFID devices detected");
			return false;
		}

		Back = FEUSB_GetScanListPara(0, "Device-ID", sDeviceID);
		// get the device-id of the first detected device
		Back = FEUSB_GetScanListSize();
		// get the device-id of the first detected device


		if (Back == 1) {

			// ideviceID = HexToInt(CStr(sDeviceID.Value)) ' convert hex id to decimal
			mystring = ByteToASCII(sDeviceID);

			nDeviceID = BitConverter.ToUInt32(sDeviceID, 0);
			iPortHnd = FEUSB_OpenDevice(nDeviceID);
			// open the channel to USB device

			// did we open the channel ?
			if (iPortHnd > 0) {
				// yes, create a reader object
				iReaderHnd = FEISC_NewReader(iPortHnd);
				functionReturnValue = true;
			} else {
				GetFeigErrorTextUSB(iPortHnd);
			}
		}
		return functionReturnValue;
	*}*/
    /*	public bool InitializeUSB_Old1_Test()
	{
		bool functionReturnValue = false;
		//UID_Array = New Byte(11) {}
		//Type(FEUSB_SCANSEARCH = record)
		//iMask:                          Integer;
		//cFamily,cProduct,cInterface:    array[0..24] of Char;
		//cDeviceID:                      array[0..8] of Char;
		//end;
		FEUSB_SCANSEARCH_BYTE pSearchOpt = new FEUSB_SCANSEARCH_BYTE();
		pSearchOpt.iMask = 0;
		 // ERROR: Not supported in C#: ReDimStatement

		 // ERROR: Not supported in C#: ReDimStatement

		 // ERROR: Not supported in C#: ReDimStatement

		 // ERROR: Not supported in C#: ReDimStatement


		FEUSB_SCANSEARCH pSearchOp1 = new FEUSB_SCANSEARCH();


		functionReturnValue = false;
		IsActive = false;
		iReaderHnd = -1;
		iPortHnd = -1;
		iReaderHnd = FEISC_NewReader(0);
		if (iReaderHnd > 0) {
			if (GetReaderText != null) {
				GetReaderText("iReaderHnd = OK");
			}
			FEUSB_ClearScanList();
			iPortHnd = FEUSB_ScanAndOpen(FEUSB_SCAN_FIRST, ref pSearchOp1);
			if (iPortHnd > 0) {
				if (GetReaderText != null) {
					GetReaderText("iPortHnd = OK");
				}
				R_Result = FEISC_SetReaderPara(iReaderHnd, GetASCIIByte("PortHnd"), GetASCIIByte(iPortHnd.ToString()));
				functionReturnValue = true;
			} else {
				GetFeigErrorTextUSB(iPortHnd);
			}
		}
		IsActive = functionReturnValue;
		if (!IsActive) {
			ReaderUnload();
		} else {
			SetOn();
		}
		return functionReturnValue;
	}*/
	/*public bool InitializeUSB_Old_Test()
	{
		bool functionReturnValue = false;
		//UID_Array = New Byte(11) {}
		//Type(FEUSB_SCANSEARCH = record)
		//iMask:                          Integer;
		//cFamily,cProduct,cInterface:    array[0..24] of Char;
		//cDeviceID:                      array[0..8] of Char;
		//end;
		//ReDim pSearchOpt.cFamilyName(0 To 24) ' = "                         " 'New Char(25) {}
		//ReDim pSearchOpt.cDeviceName(0 To 24) ' = "                         " 'New Char(25) {}
		//ReDim pSearchOpt.cInterface(0 To 24) '= "                         " 'New Char(25) {}
		//ReDim pSearchOpt.cDeviceID(0 To 7) '= "         " 'New Char(16) {}
		int isA = 0;
		string[] sDeviceID = new string[9];
		FEUSB_SCANSEARCH pSearchOpt = new FEUSB_SCANSEARCH();
		pSearchOpt.iMask = 0;
		pSearchOpt.cFamily = "";
		pSearchOpt.cProduct = "";
		pSearchOpt.cInterface = "";
		pSearchOpt.cDeviceID = "";
		functionReturnValue = false;
		IsActive = false;
		iReaderHnd = -1;
		iPortHnd = -1;
		iReaderHnd = FEISC_NewReader(0);
		if (iReaderHnd > 0) {
			if (GetReaderText != null) {
				GetReaderText("iReaderHnd = OK");
			}
			R_Result = FEISC_SetReaderPara(iReaderHnd, GetASCIIByte("FrameSupport"), GetASCIIByte("Standart"));
			FEUSB_ClearScanList();
            iPortHnd = FEUSB_ScanAndOpen(FEUSB_SCAN_FIRST, ref pSearchOpt);
			if (iPortHnd > 0) {
				if (GetReaderText != null) {
					GetReaderText("iPortHnd = OK");
				}
				R_Result = FEISC_SetReaderPara(iReaderHnd, GetASCIIByte("PortHnd"), GetASCIIByte(iPortHnd.ToString()));
				functionReturnValue = true;
			} else {
				GetFeigErrorTextUSB(iPortHnd);
			}
		}
		IsActive = InitializeUSB_ALT();
		if (!IsActive) {
			ReaderUnload();
		} else {
			SetOn();
		}
		return InitializeUSB_ALT();
		return functionReturnValue;
	}*/

	public bool Initialize(string Port)
	{
		bool functionReturnValue = false;
		functionReturnValue = false;
		IsActive = false;
		iReaderHnd = -1;
		iPortHnd = -1;
		iReaderHnd = FEISC_NewReader(0);
		if (iReaderHnd > 0) {
			if (GetReaderText != null) {
				GetReaderText("iReaderHnd = OK");
			}
			My_ComArray[0] = (byte)Convert.ToChar(Port); // Value of ASCII 49 VB.NET is ASC...function
			iPortHnd = FECOM_OpenPort(My_ComArray);
			if (iPortHnd > 0) {
				if (GetReaderText != null) {
					GetReaderText("iPortHnd = OK");
				}
				//R_Result = FEISC_SetReaderPara(iReaderHnd, GetASCIIByte("FrameSupport"), GetASCIIByte("Standart"))
				R_Result = FEISC_SetReaderPara(iReaderHnd, GetASCIIByte("PortHnd"), GetASCIIByte(iPortHnd.ToString()));
				//R_Result = FEISC_SetReaderPara(iReaderHnd, GetASCIIByte("PortHnd"), GetASCIIByte("0"))
				//iSa = FEISC_SetReaderPara(iReaderHnd, "PortHnd", iPortHnd.ToString)
				R_Result = FEISC_SetReaderPara(iPortHnd, GetASCIIByte("PowerOnTime"), GetASCIIByte("10"));
				R_Result = FEISC_SetReaderPara(iPortHnd, GetASCIIByte("WaitAfterPowerOn"), GetASCIIByte("100"));
				R_Result = FECOM_SetPortPara(iPortHnd, GetASCIIByte("Baud"), GetASCIIByte(sBaud));
				R_Result = FECOM_SetPortPara(iPortHnd, GetASCIIByte("Frame"), GetASCIIByte(sFrame));
				R_Result = FECOM_SetPortPara(iPortHnd, GetASCIIByte("Timeout"), GetASCIIByte(sTimeout));
				R_Result = FECOM_SetPortPara(iPortHnd, GetASCIIByte("CharTimeoutMpy"), GetASCIIByte("9"));
				R_Result = FECOM_DoPortCmd(iPortHnd, GetASCIIByte("SetDTR"), GetASCIIByte("ON"));
				//R_Result = FECOM_DoPortCmd(iPortHnd, GetASCIIByte("SetRTS"), GetASCIIByte("ON"))
				//Initialize = CheckFeigVersion() = 0
				functionReturnValue = true;
			} else {
				if (GetReaderText != null) {
					GetReaderText("iPortHnd = ERROR");
				}
			}
		} else {
			if (GetReaderText != null) {
				GetReaderText("iReaderHnd = ERROR");
			}
		}
		IsActive = functionReturnValue;
		if (!IsActive) {
			ReaderUnload();
		} else {
			SetOn();
		}
		return functionReturnValue;
	}

	public int ReaderUnload()
	{
		int functionReturnValue = 0;
		functionReturnValue = -1;
		if (iPortHnd > 0) {
			functionReturnValue = FECOM_ClosePort(iPortHnd);
			//functionReturnValue = FEUSB_CloseDevice(iPortHnd);
		}
		if (iReaderHnd > 0)
			functionReturnValue = FEISC_DeleteReader(iReaderHnd);
		IsActive = false;
		return functionReturnValue;
	}

	public bool GetSoftwareVersion()
	{
		SoftwareInfo = "";
		ClearArray(ref Read_Array);
		R_Result = FEISC_0x65_SoftVersion(iReaderHnd, cBusAdr, Read_Array, iDataType);
		GetErrorText(R_Result);
        SoftwareInfo = "Software Revision" + ControlChars.CrLf + "Hardware Type" + ControlChars.CrLf + "Reader Firmware" + ControlChars.CrLf + "Transponder Types";
		SoftwareInfo = ByteToHex(Read_Array);
		SoftwareInfo = SoftwareInfo.Substring(1, 16);
		return R_Result == 0;
	}

	public bool GetReaderInfo(byte index)
	{
		string tmp = "";
		int tmpint = 0;
		//SetOn()
		//Firmware Version of RF Communication Controller:
		//Software Revision:.....00-07-00
		//Hardware Type:.........= &HFE
		//Reader Type:...........93 (ID ISC.LRU2000)
		//Transponder Types:.....= &H00 = &H12
		//Max. Rx buffer size:...00280
		//Max. Tx buffer size:...00520
		//000700 FE 5D 001201180208000000
		ClearStringArray(ref InfoReader);
		R_Result = FEISC_0x66_ReaderInfo(iReaderHnd, cBusAdr, index, Read_Array, iDataType);
		GetErrorText(R_Result);
		tmp = ByteToHex(Read_Array);
		InfoReader[0] = "Software Revision:" + tmp.Substring(0, 6);
		InfoReader[1] = "Hardware Type:= 0x" + tmp.Substring(6, 2);
		tmpint = Convert.ToInt32("0x" + tmp.Substring(8, 2),16);
		InfoReader[2] = "Reader Type:" + tmpint.ToString() + " / " + GetReaderTyp(tmpint);
		//5D / 93
		InfoReader[3] = "Transponder Types:" + tmp.Substring(10, 4);
		//0012
		return R_Result == 0;
	}

	private int CheckFeigVersion()
	{
		int functionReturnValue = 0;
		functionReturnValue = 0;
		COMVersion = GetCOMDLLVersion();
		ISCVersion = GetISCDLLVersion();
		ClearArray(ref Read_Array);
		//RaiseEvent GetReaderText("CheckFeigVersion")
		//R_Result = FEISC_= &H66_ReaderInfo(iReaderHnd, cBusAdr, 1, Read_Array, iDataType)
		//GetErrorText(R_Result)
		functionReturnValue = 0;
		ReaderInfo = ByteToASCII(Read_Array);
		return functionReturnValue;
	}


	public string GetCOMDLLVersion()
	{
		string functionReturnValue = "";
		functionReturnValue = "";
		//GetDLLVersion = New String(" ", 256)
		if (GetReaderText != null) {
			GetReaderText("GetCOMDLLVersion");
		}
		FECOM_GetDLLVersion(Read_Array);
		functionReturnValue = ByteToASCII(Read_Array);
		return functionReturnValue;
	}

	public string GetISCDLLVersion()
	{
		string functionReturnValue = "";
		functionReturnValue = "";
		//GetDLLVersion = New String(" ", 256)
		if (GetReaderText != null) {
			GetReaderText("GetISCDLLVersion");
		}
		FEISC_GetDLLVersion(Read_Array);
		functionReturnValue = ByteToASCII(Read_Array);
		return functionReturnValue;
	}

	public bool WriteTagBlock(byte BNr, byte Blaenge, string Data, int Index)
	{
		bool Result = false;
		string tmpData = "";
		int erg = 0;
		int i = 0;
		//SetOn()
		erg = 16 + ((Blaenge - 1) * 4);
		Write_Array = new byte[erg + 1];
		Write_Array[0] = 36;
		Write_Array[1] = 1;
		Write_Array[2] = Convert.ToByte("0x" + UIDNr[0] + UIDNr[1],16);
        Write_Array[3] = Convert.ToByte("0x" + UIDNr[2] + UIDNr[3],16);
        Write_Array[4] = Convert.ToByte("0x" + UIDNr[4] + UIDNr[5],16);
        Write_Array[5] = Convert.ToByte("0x" + UIDNr[6] + UIDNr[7],16);
        Write_Array[6] = Convert.ToByte("0x" + UIDNr[8] + UIDNr[9],16);
        Write_Array[7] = Convert.ToByte("0x" + UIDNr[10] + UIDNr[11],16);
        Write_Array[8] = Convert.ToByte("0x" + UIDNr[12] + UIDNr[13],16);
        Write_Array[9] = Convert.ToByte("0x" + UIDNr[14] + UIDNr[15],16);
		Write_Array[10] = BNr;
		Write_Array[11] = Blaenge;
		Write_Array[12] = 4;
		for (i = Data.Length; i <= Blaenge * 4 - 1; i++) {
			Data += " ";
		}

		if (Index == 1) {
			tmpData = Data.Substring(4, 4) + Data.Substring(0, 4);
			Data = tmpData;
		}
		if (Index == 2) {
			if (Blaenge == 8) {
				tmpData = Data.Substring(28, 4) + Data.Substring(24, 4) + Data.Substring(20, 4) + Data.Substring(16, 4) + Data.Substring(12, 4) + Data.Substring(8, 4) + Data.Substring(4, 4) + Data.Substring(0, 4);
				Data = tmpData;
			}
			if (Blaenge == 32) {
				tmpData = Data.Substring(124, 4) + Data.Substring(120, 4) + Data.Substring(116, 4) + Data.Substring(112, 4) + Data.Substring(108, 4) + Data.Substring(104, 4) + Data.Substring(100, 4) + Data.Substring(96, 4) + Data.Substring(92, 4) + Data.Substring(88, 4) + Data.Substring(84, 4) + Data.Substring(80, 4) + Data.Substring(76, 4) + Data.Substring(72, 4) + Data.Substring(68, 4) + Data.Substring(64, 4) + Data.Substring(60, 4) + Data.Substring(56, 4) + Data.Substring(52, 4) + Data.Substring(48, 4) + Data.Substring(44, 4) + Data.Substring(40, 4) + Data.Substring(36, 4) + Data.Substring(32, 4) + Data.Substring(28, 4) + Data.Substring(24, 4) + Data.Substring(20, 4) + Data.Substring(16, 4) + Data.Substring(12, 4) + Data.Substring(8, 4) + Data.Substring(4, 4) + Data.Substring(0, 4);
				Data = tmpData;
			}
		}

		for (i = 13; i <= erg; i++) {
			Write_Array[i] = (byte)Convert.ToChar(Data[i - 13]);
		}

		R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, Write_Array, Write_Array.Length, cRspData, ref iRspLen, iDataType);

		Result = R_Result == 0;
		return Result;
	}

	public bool WriteTagBlock24(byte BNr, byte Blaenge, string Data, int Index)
	{
		bool Result = false;
		string tmpData = string.Empty;
		int erg = 0;
		int i = 0;
		//SetOn()
		if (UIDNr.Length != 24)
			return false;

		erg = 20 + (Blaenge * 2) - 1;
		Write_Array = new byte[erg + 1];
		Write_Array[0] = 36;
		Write_Array[1] = 49;
		Write_Array[2] = 12;
		Write_Array[3] = Convert.ToByte("0x" + UIDNr[0] + UIDNr[1],16);
        Write_Array[4] = Convert.ToByte("0x" + UIDNr[2] + UIDNr[3],16);
        Write_Array[5] = Convert.ToByte("0x" + UIDNr[4] + UIDNr[5],16);
        Write_Array[6] = Convert.ToByte("0x" + UIDNr[6] + UIDNr[7],16);
        Write_Array[7] = Convert.ToByte("0x" + UIDNr[8] + UIDNr[9],16);
        Write_Array[8] = Convert.ToByte("0x" + UIDNr[10] + UIDNr[11],16);
        Write_Array[9] = Convert.ToByte("0x" + UIDNr[12] + UIDNr[13],16);
        Write_Array[10] = Convert.ToByte("0x" + UIDNr[14] + UIDNr[15],16);
        Write_Array[11] = Convert.ToByte("0x" + UIDNr[16] + UIDNr[17],16);
        Write_Array[12] = Convert.ToByte("0x" + UIDNr[18] + UIDNr[19],16);
        Write_Array[13] = Convert.ToByte("0x" + UIDNr[20] + UIDNr[21],16);
        Write_Array[14] = Convert.ToByte("0x" + UIDNr[22] + UIDNr[23],16);
		Write_Array[15] = 3;
		Write_Array[16] = 0;
		Write_Array[17] = BNr;
		//      // Address
		Write_Array[18] = Blaenge;
		//  // Number of Block
		Write_Array[19] = 2;
		//      //   Block Size

        for (i = Data.Length; i <= Blaenge * 2 - 1; i++) {
			Data += " ";
		}

		if (Index == 1) {
			tmpData = Data.Substring(4, 2) + Data.Substring(0, 2);
			Data = tmpData;
		}
		if (Index == 2) {
			if (Blaenge == 8) {
				tmpData = Data.Substring(28, 4) + Data.Substring(24, 4) + Data.Substring(20, 4) + Data.Substring(16, 4) + Data.Substring(12, 4) + Data.Substring(8, 4) + Data.Substring(4, 4) + Data.Substring(0, 4);
				Data = tmpData;
			}
			if (Blaenge == 32) {
				tmpData = Data.Substring(124, 4) + Data.Substring(120, 4) + Data.Substring(116, 4) + Data.Substring(112, 4) + Data.Substring(108, 4) + Data.Substring(104, 4) + Data.Substring(100, 4) + Data.Substring(96, 4) + Data.Substring(92, 4) + Data.Substring(88, 4) + Data.Substring(84, 4) + Data.Substring(80, 4) + Data.Substring(76, 4) + Data.Substring(72, 4) + Data.Substring(68, 4) + Data.Substring(64, 4) + Data.Substring(60, 4) + Data.Substring(56, 4) + Data.Substring(52, 4) + Data.Substring(48, 4) + Data.Substring(44, 4) + Data.Substring(40, 4) + Data.Substring(36, 4) + Data.Substring(32, 4) + Data.Substring(28, 4) + Data.Substring(24, 4) + Data.Substring(20, 4) + Data.Substring(16, 4) + Data.Substring(12, 4) + Data.Substring(8, 4) + Data.Substring(4, 4) + Data.Substring(0, 4);
				Data = tmpData;
			}
		}

		for (i = 20; i <= erg; i++) {
			Write_Array[i] = (byte)Convert.ToChar(Data[i - 20]);
		}

		R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, Write_Array, Write_Array.Length, cRspData, ref iRspLen, iDataType);

		Result = R_Result == 0;
		return Result;
	}

	public bool ReadTagBlock24(byte BNr, byte BLaenge, int Index)
	{
		bool Result = false;
		int i = 0;
		int BStart = 3;
		int BStop = 4;
		string tmpData = "";

		//05000000000000000001E0C9
		//B0 23 11   0C (längenflag)   05 00 00 00 00 00 00 00 00 01 E0 C9     02 06 Adress+Blocklänge
		//09/07/09 15:49:39.500  >>  02 00 18 FF B0 23 11 0C 05 00 00 00 00 00 00 00 00 01 E0 C9 02 06 3C E4
		//09/07/09 15:49:39.593  <<  02 00 1C 00 B0 00 06 02 00 05 00 00 00 00 00 00 00 00 00 00 00 00 01 00 E0 C9 0B 8C   OK
		//09/08/09 11:22:02.000  >>  02 00 1A FF B0 23 31 0C 05 00 00 00 00 00 00 00 00 01 E0 C9  03  00  08 05  83 52
		//09/08/09 11:22:02.109  <<  02 00 19 00 B0 00 05 02 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 6C A3   OK
		BlockDataHex = "";
		//SetOn()
		cRspData = new byte[512];
		R_Result = -1;
		if (UIDNr.Length != 24)
			return false;
		UID_Array24[0] = 35;
		UID_Array24[1] = 49;
		UID_Array24[2] = 12;

		UID_Array24[3] = Convert.ToByte("0x" + UIDNr[0] + UIDNr[1],16);
        UID_Array24[4] = Convert.ToByte("0x" + UIDNr[2] + UIDNr[3],16);
        UID_Array24[5] = Convert.ToByte("0x" + UIDNr[4] + UIDNr[5],16);
        UID_Array24[6] = Convert.ToByte("0x" + UIDNr[6] + UIDNr[7],16);
        UID_Array24[7] = Convert.ToByte("0x" + UIDNr[8] + UIDNr[9],16);
        UID_Array24[8] = Convert.ToByte("0x" + UIDNr[10] + UIDNr[11],16);
        UID_Array24[9] = Convert.ToByte("0x" + UIDNr[12] + UIDNr[13],16);
        UID_Array24[10] = Convert.ToByte("0x" + UIDNr[14] + UIDNr[15],16);
        UID_Array24[11] = Convert.ToByte("0x" + UIDNr[16] + UIDNr[17],16);
        UID_Array24[12] = Convert.ToByte("0x" + UIDNr[18] + UIDNr[19],16);
        UID_Array24[13] = Convert.ToByte("0x" + UIDNr[20] + UIDNr[21],16);
        UID_Array24[14] = Convert.ToByte("0x" + UIDNr[22] + UIDNr[23],16);
		UID_Array24[15] = 3;
		UID_Array24[16] = 0;
		UID_Array24[17] = BNr;
		//    UIDBlock24[11] :=   '02; 2 Blöcke, 08 = 8 Blöcke
		UID_Array24[18] = BLaenge;
		iRspLen = 0;
		R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, UID_Array24, 19, cRspData, ref iRspLen, iDataType);
        if (R_Result == 0)
        {
            if (iRspLen > 0)
            {
                if (Index == 0 | Index == 1)
                {
                    for (i = 1; i <= cRspData[0]; i++)
                    {
                        if (Index == 0)
                            BlockDataHex = BlockDataHex + GetByteDataBufferToHex(cRspData, BStart, BStop);
                        if (Index == 1)
                            BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, BStop) + BlockDataHex;
                        BStart = BStart + 3;
                        BStop = BStop + 3;
                    }
                    BlockDataAScII = HexToASCII(BlockDataHex);
                }
                if (Index == 2 & BLaenge == 8)
                {
                    BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, iRspLen - 1);
                    tmpData = BlockDataHex.Substring(70, 8) + BlockDataHex.Substring(60, 8) + BlockDataHex.Substring(50, 8) + BlockDataHex.Substring(40, 8) + BlockDataHex.Substring(30, 8) + BlockDataHex.Substring(20, 8) + BlockDataHex.Substring(10, 8) + BlockDataHex.Substring(0, 8);
                    BlockDataAScII = HexToASCII(tmpData);
                }
                if (Index == 2 & BLaenge == 32)
                {
                    BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, iRspLen - 1);
                    tmpData = BlockDataHex.Substring(310, 8) + BlockDataHex.Substring(300, 8) + BlockDataHex.Substring(290, 8) + BlockDataHex.Substring(280, 8) + BlockDataHex.Substring(270, 8) + BlockDataHex.Substring(260, 8) + BlockDataHex.Substring(250, 8) + BlockDataHex.Substring(240, 8) + BlockDataHex.Substring(230, 8) + BlockDataHex.Substring(220, 8) + BlockDataHex.Substring(210, 8) + BlockDataHex.Substring(200, 8) + BlockDataHex.Substring(190, 8) + BlockDataHex.Substring(180, 8) + BlockDataHex.Substring(170, 8) + BlockDataHex.Substring(160, 8) + BlockDataHex.Substring(150, 8) + BlockDataHex.Substring(140, 8) + BlockDataHex.Substring(130, 8) + BlockDataHex.Substring(120, 8) + BlockDataHex.Substring(110, 8) + BlockDataHex.Substring(100, 8) + BlockDataHex.Substring(90, 8) + BlockDataHex.Substring(80, 8) + BlockDataHex.Substring(70, 8) + BlockDataHex.Substring(60, 8) + BlockDataHex.Substring(50, 8) + BlockDataHex.Substring(40, 8) + BlockDataHex.Substring(30, 8) + BlockDataHex.Substring(20, 8) + BlockDataHex.Substring(10, 8) + BlockDataHex.Substring(0, 8);
                    BlockDataAScII = HexToASCII(tmpData);
                }

            }
        }
        else
        {
            GetFeigErrorText(R_Result);
        }
		Result = R_Result == 0;
		return Result;
	}

	public bool ReadMifare(byte BNr, byte BLaenge, int Index)
	{
		bool Result = false;
		int i = 0;
		int BStart = 3;
		int BStop = 18;
		BlockDataHex = "";
		//SetOn()
		cRspData = new byte[512];
		R_Result = -1;

		//09 FF B0 23 02 00 04 1A C8
		ReadMi_Array[0] = 35;
		// hex 23 = DataBlock   ' hex 0A = ConfigBlock (geht nicht)
		ReadMi_Array[1] = 2;
		// Mode Addressed selected, ist immer 2
		ReadMi_Array[2] = BNr;
		ReadMi_Array[3] = BLaenge;
		iReqLen = ReadMi_Array.Length;
		iRspLen = cRspData.Length;
		//SetOn()
		iRspLen = 0;
		R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, ReadMi_Array, iReqLen, cRspData, ref iRspLen, iDataType);
		GetErrorText(R_Result);
		if (R_Result == 0) {
			if (iRspLen > 0) {
				if (Index == 0 | Index == 1) {
					for (i = 1; i <= cRspData[0]; i++) {
						if (Index == 0)
							BlockDataHex = BlockDataHex + GetByteDataBufferToHexInverted(cRspData, BStart, BStop);
						if (Index == 1)
							BlockDataHex = GetByteDataBufferToHexInverted(cRspData, BStart, BStop) + BlockDataHex;
						BStart = BStart + 5;
						BStop = BStop + 5;
					}
					BlockDataAScII = HexToASCII(BlockDataHex);
				}
			}
		}
		Result = R_Result == 0;
		return Result;
	}


	public bool WriteMifare(byte BNr, byte BLaenge, string Data, int Index)
	{
		bool Result = false;
		int i = 0;
		int erg = 0;
		BlockDataHex = "";
		//SetOn()
		cRspData = new byte[512];
		R_Result = -1;

		//1A FF B0 24 02  01 01  10  00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 69 27 
		//2A FF B0 24 02  02 02  10  00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 14 77 

		//09 FF B0 23 02 00 04 1A C8
		erg = 5 + (BLaenge * 16) - 1;
		WriteMi_Array = new byte[erg + 1];


		WriteMi_Array[0] = 36;
		// hex 24 = DataBlock 
		WriteMi_Array[1] = 2;
		// Mode Addressed selected, ist immer 2
		WriteMi_Array[2] = BNr;
		WriteMi_Array[3] = BLaenge;
		WriteMi_Array[4] = 16;
		//Block-Size, ist fix



		for (i = Data.Length; i <= BLaenge * 16 - 1; i++) {
			Data += " ";
		}

		Data = GetInverted(Data);

		for (i = 5; i <= erg; i++) {
			WriteMi_Array[i] = (byte)Convert.ToChar(Data[i - 5]);
		}

		iReqLen = WriteMi_Array.Length;
		iRspLen = cRspData.Length;
		//SetOn()
		iRspLen = 0;
		R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, WriteMi_Array, iReqLen, cRspData, ref iRspLen, iDataType);
		GetErrorText(R_Result);

		Result = R_Result == 0;
		return Result;
	}

	public bool ReadTagBlock(byte BNr, byte BLaenge, int Index)
	{
		bool Result = false;
		int i = 0;
		int BStart = 3;
		int BStop = 6;
		string tmpData = "";
		BlockDataHex = "";
		//SetOn()
		cRspData = new byte[512];
		R_Result = -1;
		if (UIDNr.Length != 16)
			return false ;
		UID_Array[0] = 35;
		UID_Array[1]= 1;
		UID_Array[2] = Convert.ToByte("0x" + UIDNr[0] + UIDNr[1],16);
        UID_Array[3] = Convert.ToByte("0x" + UIDNr[2] + UIDNr[3],16);
        UID_Array[4] = Convert.ToByte("0x" + UIDNr[4] + UIDNr[5],16);
        UID_Array[5] = Convert.ToByte("0x" + UIDNr[6] + UIDNr[7],16);
        UID_Array[6] = Convert.ToByte("0x" + UIDNr[8] + UIDNr[9],16);
        UID_Array[7] = Convert.ToByte("0x" + UIDNr[10] + UIDNr[11],16);
        UID_Array[8] = Convert.ToByte("0x" + UIDNr[12] + UIDNr[13],16);
        UID_Array[9] = Convert.ToByte("0x" + UIDNr[14] + UIDNr[15],16);

		UID_Array[10] = BNr;
		//    UIDBlock[11] :=   '02; 2 Blöcke, 08 = 8 Blöcke
		UID_Array[11] = BLaenge;
		iRspLen = 0;
		R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, UID_Array, 12, cRspData, ref iRspLen, iDataType);
        if (R_Result == 0)
        {
            if (iRspLen > 0)
            {
                if (Index == 0 | Index == 1)
                {
                    for (i = 1; i <= cRspData[0]; i++)
                    {
                        if (Index == 0)
                            BlockDataHex = BlockDataHex + GetByteDataBufferToHex(cRspData, BStart, BStop);
                        if (Index == 1)
                            BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, BStop) + BlockDataHex;
                        BStart = BStart + 5;
                        BStop = BStop + 5;
                    }
                    BlockDataAScII = HexToASCII(BlockDataHex);
                }
                if (Index == 2 & BLaenge == 8)
                {
                    BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, iRspLen - 1);
                    tmpData = BlockDataHex.Substring(70, 8) + BlockDataHex.Substring(60, 8) + BlockDataHex.Substring(50, 8) + BlockDataHex.Substring(40, 8) + BlockDataHex.Substring(30, 8) + BlockDataHex.Substring(20, 8) + BlockDataHex.Substring(10, 8) + BlockDataHex.Substring(0, 8);
                    BlockDataAScII = HexToASCII(tmpData);
                }
                if (Index == 2 & BLaenge == 32)
                {
                    BlockDataHex = GetByteDataBufferToHex(cRspData, BStart, iRspLen - 1);
                    tmpData = BlockDataHex.Substring(310, 8) + BlockDataHex.Substring(300, 8) + BlockDataHex.Substring(290, 8) + BlockDataHex.Substring(280, 8) + BlockDataHex.Substring(270, 8) + BlockDataHex.Substring(260, 8) + BlockDataHex.Substring(250, 8) + BlockDataHex.Substring(240, 8) + BlockDataHex.Substring(230, 8) + BlockDataHex.Substring(220, 8) + BlockDataHex.Substring(210, 8) + BlockDataHex.Substring(200, 8) + BlockDataHex.Substring(190, 8) + BlockDataHex.Substring(180, 8) + BlockDataHex.Substring(170, 8) + BlockDataHex.Substring(160, 8) + BlockDataHex.Substring(150, 8) + BlockDataHex.Substring(140, 8) + BlockDataHex.Substring(130, 8) + BlockDataHex.Substring(120, 8) + BlockDataHex.Substring(110, 8) + BlockDataHex.Substring(100, 8) + BlockDataHex.Substring(90, 8) + BlockDataHex.Substring(80, 8) + BlockDataHex.Substring(70, 8) + BlockDataHex.Substring(60, 8) + BlockDataHex.Substring(50, 8) + BlockDataHex.Substring(40, 8) + BlockDataHex.Substring(30, 8) + BlockDataHex.Substring(20, 8) + BlockDataHex.Substring(10, 8) + BlockDataHex.Substring(0, 8);
                    BlockDataAScII = HexToASCII(tmpData);
                }

            }
        }
        else
        {
            GetFeigErrorText(R_Result);
        }
		Result = R_Result == 0;
		return Result;
	}

	public bool SelectMifare()
	{
		bool functionReturnValue = false;
		string tmpE = "";
		int i = 0;
		functionReturnValue = false;
		//R_Result = FEISC_0x69_RFReset(iReaderHnd, cBusAdr)

		//cReqData(0) = 1  '01 00
		//cReqData(1) = 0
		//iReqLen = cReqData.Length
		//iRspLen = cRspData.Length
		tmpE = UIDNr;
		for (i = UIDNr.Length; i <= 16 - 1; i++) {
			tmpE = "0" + tmpE;
		}

		SelMifare_Array[0] = 37;
		SelMifare_Array[1] = 1;

		SelMifare_Array[2] = Convert.ToByte("0x" + tmpE[0] + tmpE[1],16);
        SelMifare_Array[3] = Convert.ToByte("0x" + tmpE[2] + tmpE[3],16);
        SelMifare_Array[4] = Convert.ToByte("0x" + tmpE[4] + tmpE[5],16);
        SelMifare_Array[5] = Convert.ToByte("0x" + tmpE[6] + tmpE[7],16);
        SelMifare_Array[6] = Convert.ToByte("0x" + tmpE[8] + tmpE[9],16);
        SelMifare_Array[7] = Convert.ToByte("0x" + tmpE[10] + tmpE[11],16);
        SelMifare_Array[8] = Convert.ToByte("0x" + tmpE[12] + tmpE[13],16);
        SelMifare_Array[9] = Convert.ToByte("0x" + tmpE[14] + tmpE[15],16);

		iReqLen = SelMifare_Array.Length;
		iRspLen = cRspData.Length;


		//SetOn()
		// B0 25 01 00 00 00 00 A6 8A B4 B6 26 2D 
		// iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cReqData As Byte, ByVal iReqLen As Integer, ByRef cRspData As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
		R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, SelMifare_Array, iReqLen, cRspData, ref iRspLen, iDataType);
		GetErrorText(R_Result);
		functionReturnValue = R_Result == 0;
		return functionReturnValue;
	}

	public bool SetKeyMifare(byte Block)
	{
		bool functionReturnValue = false;
		functionReturnValue = false;
		//R_Result = FEISC_0x69_RFReset(iReaderHnd, cBusAdr)

		//cReqData(0) = 1  '01 00
		//cReqData(1) = 0
		//iReqLen = cReqData.Length
		//iRspLen = cRspData.Length
		Key_Array[0] = 176;
		Key_Array[1] = 10;

		Key_Array[2] = Block;
		// DB Adresse
		Key_Array[3] = 0;
		// Key A = 0, Key B = 1

		if (MifareKey.Length == 12) {
			Key_Array[4] = Convert.ToByte("0x" + MifareKey[0] + MifareKey[1],16);
            Key_Array[5] = Convert.ToByte("0x" + MifareKey[0] + MifareKey[1],16);
            Key_Array[6] = Convert.ToByte("0x" + MifareKey[0] + MifareKey[1],16);
            Key_Array[7] = Convert.ToByte("0x" + MifareKey[0] + MifareKey[1],16);
            Key_Array[8] = Convert.ToByte("0x" + MifareKey[0] + MifareKey[1],16);
            Key_Array[9] = Convert.ToByte("0x" + MifareKey[0] + MifareKey[1],16);
		} else {
			Key_Array[4] = 0;
			Key_Array[5] = 0;
			Key_Array[6] = 0;
			Key_Array[7] = 0;
			Key_Array[8] = 0;
			Key_Array[9] = 0;
		}

		iReqLen = Key_Array.Length;
		iRspLen = cRspData.Length;


		//SetOn()
		//FEISC_0xB2_ISOCmd(ByVal
		// B0 0A 00 00 FF FF FF FF FF FF 
		// iReaderHnd As Integer, ByVal cBusAdr As Byte, ByRef cReqData As Byte, ByVal iReqLen As Integer, ByRef cRspData As Byte, ByRef iRspLen As Integer, ByVal iDataFormat As Integer) As Integer
		//00 00 FF FF FF FF FF FF 
		R_Result = FEISC_0xB2_ISOCmd(iReaderHnd, cBusAdr, Key_Array, iReqLen, cRspData, ref iRspLen, iDataType);
		GetErrorText(R_Result);
		functionReturnValue = R_Result == 0;
		return functionReturnValue;
	}

	public bool GetUID()
	{
		bool functionReturnValue = false;
		R_Result = FEISC_0x69_RFReset(iReaderHnd, cBusAdr);
		UIDNr = "";
		cReqData[0] = 1;
		//01 00
		cReqData[1] = 0;
		iReqLen = cReqData.Length;
		iRspLen = cRspData.Length;
		//SetOn()
		R_Result = FEISC_0xB0_ISOCmd(iReaderHnd, cBusAdr, cReqData, iReqLen, cRspData, ref iRspLen, iDataType);
		GetErrorText(R_Result);
		if (R_Result == 0) {
			if (iRspLen > 0) {
				UIDNr = GetByteBufferToHex(cRspData, iRspLen);
				UIDNr = CheckTAGData(UIDNr);
			}
		}
		functionReturnValue = R_Result == 0;
		return functionReturnValue;
	}

	private string CheckTAGData(string Data)
	{
    	int Tags = 0;
        string tmp = "";
		//Dim uTagTyp As String
		string uTagNr = "";
		TagTyp = "";
        if (Data.Length < 22)
            return uTagNr;
		Tags = Convert.ToInt32(Data.Substring(0, 2));
		Data = Data.Substring(2, Data.Length - 2);
		if (Tags == 1) {
			tmp = Data.Substring(0, 2);
			TagTyp = GetTransponderTyp(Convert.ToInt32(tmp));
			//If tmp = "80" Then
			//TagTyp = "18000-6-A"
			//ElseIf tmp = "81" Then
			//   TagTyp = "18000-6-B "
			//ElseIf tmp = "83" Then
			//TagTyp = "EM4222"
			//ElseIf tmp = "84" Then
			//TagTyp = "EPC Gen 2"
			//ElseIf tmp = "89" Then
			//TagTyp = "EPC Class 1"
			//ElseIf tmp = "03" Then
			//TagTyp = "ISO 15693"
			//ElseIf tmp = "06" Then
			//TagTyp = "I-Code EPC"
			//ElseIf tmp = "07" Then
			//TagTyp = "I-Code UID"
			//Else : TagTyp = "UHF (unknown)"
			//End If
			if (tmp == "03") {
				uTagNr = Data.Substring(4, 24);
			} else {
				uTagNr = Data.Substring(10, 24);
			}
		}
		return uTagNr;
	}

    public int SetRF_ON_OFF(byte index)
    {
        R_Result = -1;
        R_Result = FEISC_0x6A_RFOnOff(iReaderHnd, 255, index);
        GetErrorText(R_Result);
        return R_Result;
    }

    public int SetConfig_RFPower()
    {
        R_Result = -1;
        ClearArray(ref Config_Array);
        R_Result = FEISC_0x80_ReadConfBlock(iReaderHnd, 255, 164, Config_Array, iDataType);
        if (R_Result == 0){
            Config_Array[2] = Convert.ToByte(RFPower);
            R_Result = FEISC_0x81_WriteConfBlock(iReaderHnd, 255, 164, Config_Array, iDataType);
        }
        GetErrorText(R_Result);
        return R_Result;
    }

    public int GetConfig_RFPower() 
    {
        R_Result = -1;
        RFPower = -1;
        ClearArray(ref Config_Array);
        R_Result = FEISC_0x80_ReadConfBlock(iReaderHnd, 255, 164, Config_Array, iDataType);
        RFPower = Config_Array[2];
        GetErrorText(R_Result);
        return R_Result;
    }


	public int SetISOMode(byte index)
	{
		Config_Array[0] = 0;
		Config_Array[1] = 0;
		Config_Array[2] = 8;
		Config_Array[3] = 1;
		Config_Array[4] = 0;
		Config_Array[5] = 0;
		Config_Array[6] = 0;
		Config_Array[7] = 30;
		// 1E
		Config_Array[8] = 0;
		Config_Array[9] = 0;
		Config_Array[10] = 0;
		Config_Array[11] = 0;
		Config_Array[12] = 0;
		Config_Array[13] = index;
		//  0 = ISOHost 1 = ISOScan
		R_Result = FEISC_0x81_WriteConfBlock(iReaderHnd, 255, 129, Config_Array, iDataType);
		GetErrorText(R_Result);
		if (R_Result == 0) {
			R_Result = FEISC_0x82_SaveConfBlock(iReaderHnd, 255, 1);
			GetErrorText(R_Result);
		}
		return R_Result;
	}


	/*public override void New()
	{
		Read_Array = new byte[256];
		Write_Array = new byte[256];
		My_ComArray = new byte[4];
		Config_Array = new byte[14];
		cReqData = new byte[2];
		cRspData = new byte[512];
		Info_Array = new byte[512];
		UID_Array = new byte[12];
		UID_Array24 = new byte[19];
		Key_Array = new byte[10];
		SelMifare_Array = new byte[10];
		Value_Array = new byte[17];
		InfoReader = new string[6];
		ReadMi_Array = new byte[4];
		WriteMi_Array = new byte[22];
		Error_Array = new byte[256];
	}*)

	/*protected override void Finalize()
	{
		ReaderUnload();
		base.Finalize();
	}*/


	public string GetTransponderTyp(int iStatus)
	{
		string result = string.Empty;
		// Wurde umgebaut..weil die werte in Hex sind
		int htmp = 0;
		try {
			htmp = Convert.ToInt32("0x" + iStatus.ToString(),16);
		} catch (Exception ex) {
			htmp = -1;
		}
		switch (htmp) {
			case FEDM_ISC_TR_TYPE_ICODE1:
				result = FEDM_ISC_TR_NAME_ICODE1;
				break;
			case FEDM_ISC_TR_TYPE_TAGIT:
				result = FEDM_ISC_TR_NAME_TAGIT;
				break;
			case FEDM_ISC_TR_TYPE_ISO15693:
				result = FEDM_ISC_TR_NAME_ISO15693;
				break;
			case FEDM_ISC_TR_TYPE_ISO14443A:
				result = FEDM_ISC_TR_NAME_ISO14443A;
				break;
			case FEDM_ISC_TR_TYPE_ISO14443B:
				result = FEDM_ISC_TR_NAME_ISO14443B;
				break;
			case FEDM_ISC_TR_TYPE_EPC:
				result = FEDM_ISC_TR_NAME_EPC;
				break;
			case FEDM_ISC_TR_TYPE_ICODE_UID:
				result = FEDM_ISC_TR_NAME_ICODE_UID;
				break;
			case FEDM_ISC_TR_TYPE_JEWEL:
				result = FEDM_ISC_TR_NAME_JEWEL;
				break;
			case FEDM_ISC_TR_TYPE_0x64:
				result = FEDM_ISC_TR_NAME_0x64;
				break;
			// UHF transponder types
			case FEDM_ISC_TR_TYPE_ISO18000_6_A:
				result = FEDM_ISC_TR_NAME_ISO18000_6_A;
				break;
			case FEDM_ISC_TR_TYPE_ISO18000_6_B:
				result = FEDM_ISC_TR_NAME_ISO18000_6_B;
				break;
			case FEDM_ISC_TR_TYPE_EM4222:
				result = FEDM_ISC_TR_NAME_EM4222;
				break;
			case FEDM_ISC_TR_TYPE_EPC_CLASS1_GEN2:
				result = FEDM_ISC_TR_NAME_EPC_CLASS1_GEN2;
				break;
			case FEDM_ISC_TR_TYPE_EPC_CLASS0:
				result = FEDM_ISC_TR_NAME_EPC_CLASS0;
				break;
			case FEDM_ISC_TR_TYPE_EPC_CLASS1_GEN1:
				result = FEDM_ISC_TR_NAME_EPC_CLASS1_GEN1;
				break;
			case FEDM_ISC_TR_TYPE_EPC_GEN2_HF:
				result = FEDM_ISC_TR_NAME_EPC_GEN2_HF;
				break;
			case FEDM_ISC_TR_TYPE_STM_SR176:
				result = FEDM_ISC_TR_NAME_STM_SR176;
				break;
			case FEDM_ISC_TR_TYPE_STM_SRIxx:
				result = FEDM_ISC_TR_NAME_STM_SRIxx;
				break;
			case FEDM_ISC_TR_TYPE_MCRF45x:
				result = FEDM_ISC_TR_NAME_MCRF45x;
				break;
			default:
				result = "unbekannter Typ";
				break;
		}
		return result;
	}

	public string GetReaderTyp(int istatus)
	{
		string Result = "";
		switch (istatus) {
			case FEDM_ISC_TYPE_ISCPRHD102_X:
				Result = FEDM_ISC_NAME_ISCPRHD102_X;
				break;
			case FEDM_ISC_TYPE_ISCM01:
				Result = FEDM_ISC_NAME_ISCM01;
				break;
			case FEDM_ISC_TYPE_ISCM02:
				Result = FEDM_ISC_NAME_ISCM02;
				break;
			case FEDM_ISC_TYPE_ISCLR100:
				Result = FEDM_ISC_NAME_ISCLR100;
				break;
			case FEDM_ISC_TYPE_ISCLR200:
				Result = FEDM_ISC_NAME_ISCLR200;
				break;
			case FEDM_ISC_TYPE_ISCLR2000:
				Result = FEDM_ISC_NAME_ISCLR2000;
				break;
			case FEDM_ISC_TYPE_ISCPRH101:
				Result = FEDM_ISC_NAME_ISCPRH101;
				break;
			case FEDM_ISC_TYPE_ISCPRH101_U:
				Result = FEDM_ISC_NAME_ISCPRH101_U;
				break;
			case FEDM_ISC_TYPE_ISCPRH100_U:
				Result = FEDM_ISC_NAME_ISCPRH100_U;
				break;
			case FEDM_ISC_TYPE_ISCPRH100:
				Result = FEDM_ISC_NAME_ISCPRH100;
				break;
			case FEDM_ISC_TYPE_ISCMR100_U:
				Result = FEDM_ISC_NAME_ISCMR100_U;
				break;
			case FEDM_ISC_TYPE_ISCMR100:
				Result = FEDM_ISC_NAME_ISCMR100;
				break;
			case FEDM_ISC_TYPE_ISCMR200:
				Result = FEDM_ISC_NAME_ISCMR200;
				break;
			case FEDM_ISC_TYPE_ISCMR101:
				Result = FEDM_ISC_NAME_ISCMR101;
				break;
			case FEDM_ISC_TYPE_ISCMR101_U:
				Result = FEDM_ISC_NAME_ISCMR101_U;
				break;
			case FEDM_ISC_TYPE_CPRM02:
				Result = FEDM_ISC_NAME_CPRM02;
				break;
			case FEDM_ISC_TYPE_CPR02:
				Result = FEDM_ISC_NAME_CPRM02_U;
				break;
			case FEDM_ISC_TYPE_CPRM02_U:
				Result = FEDM_ISC_NAME_CPR02;
				break;
			case FEDM_ISC_TYPE_CPR02_U:
				Result = FEDM_ISC_NAME_CPR02_U;
				break;
			case FEDM_ISC_TYPE_CPRM03:
				Result = FEDM_ISC_NAME_CPRM03;
				break;
			case FEDM_ISC_TYPE_CPR03:
				Result = FEDM_ISC_NAME_CPR03;
				break;
			case FEDM_ISC_TYPE_CPR04:
				Result = FEDM_ISC_NAME_CPR04;
				break;
			case FEDM_ISC_TYPE_CPR04_U:
				Result = FEDM_ISC_NAME_CPR04_U;
				break;
			case FEDM_ISC_TYPE_ISCLRU1000:
				Result = FEDM_ISC_NAME_ISCLRU1000;
				break;
			case FEDM_ISC_TYPE_ISCLRU2000:
				Result = FEDM_ISC_NAME_ISCLRU2000;
				break;
			default:
				Result = "unbekannter Typ";
				break;
		}
		return Result;
	}

	public string GetFeigErrorTextUSB(int iStatus)
	{
		string Result = "";
		byte[] MyError = new byte[256];
		//Dim MyError As New ArrayList
		//Dim MyError As New FixedLengthString(512)
		ClearArray(ref Error_Array);
		FEUSB_GetErrorText(iStatus, MyError);
		Result = ByteToASCII(MyError);
		Info_Text = iStatus.ToString() + "/" + Result;
		if (GetReaderText != null) {
			GetReaderText(Info_Text);
		}
		return Result;
	}

	public string GetFeigErrorText(int iStatus)
	{
		string Result = "";
		byte[] MyError = new byte[256];
		//Dim MyError As New ArrayList
		//Dim MyError As New FixedLengthString(512)
		ClearArray(ref Error_Array);
		FEISC_GetErrorText(iStatus, MyError);
		Result = ByteToASCII(MyError);
		Info_Text = iStatus.ToString() + "/" + Result;
		if (GetReaderText != null) {
			GetReaderText(Info_Text);
		}
		return Result;
	}

	public string GetErrorText(int iStatus)
	{
		string Result = "";
		switch (iStatus) {
			case 0x0:
				Result = "OK";
				break;
			//   Statusmeldung vom Reader
			case 0x1:
				Result = "Reader: No Transponder in Reader Field";
				break;
			case 0x2:
				Result = "Transponder: CRC Error";
				break;
			case 0x3:
				Result = "Transponder: Write Error";
				break;
			case 0x4:
				Result = "Transponder: Adress Error";
				break;
			case 0x5:
				Result = "Reader: Wrong Transponder Type";
				break;
			case 0x6:
				Result = "Transponder: Read Error";
				break;
			case 0x7:
				Result = "Reader: Select Error";
				break;
			case 0xa:
				Result = "Reader: Transponder Changed";
				break;
			case 0xb:
				Result = "Transponder: Collision";
				break;
			case 0xc:
				Result = "Transponder: Weak Collision";
				break;
			case 0xd:
				Result = "Transponder: Halt Error";
				break;
			case 0xe:
				Result = "Reader: No New Selected Transponders";
				break;
			case 0xf:
				Result = "Reader: Busy";
				break;
			case 0x10:
				Result = "Reader: EEPROM Error";
				break;
			case 0x11:
				Result = "Reader: Parameter Range Error";
				break;
			case 0x80:
				Result = "Reader: Unknown Command";
				break;
			case 0x81:
				Result = "Reader: Protocol Length Error";
				break;
			case 0x82:
				Result = "Reader: Command not available";
				break;
			case 0x83:
				Result = "Reader: RF Communication Error";
				break;
			case 0x90:
				Result = "Reader: Data Buffer Overrun";
				break;
			case 0x92:
				Result = "Reader: No Valid Data";
				break;
			case 0x93:
				Result = "Reader: Data Buffer Overflow";
				break;
			case 0x94:
				Result = "Reader: Poll Buffer Overflow";

				break;
			//   Fehlertexte für FECOM
			case -1000:
				Result = "FECOM: Fehler beim Erstellen eines neuen Port-Objekts";
				break;
			case -1001:
				Result = "FECOM: Port-Handleliste ist leer";
				break;
			case -1002:
				Result = "FECOM: ein Zeiger ist Null, also ungültig";
				break;
			case -1003:
				Result = "FECOM: Speichermangel";
				break;
			case -1004:
				Result = "FECOM: nicht unterstützte Hardware.";
				break;
			case -1005:
				Result = "FECOM: Rückgabe FECOM_DetectPort, Port nicht vorhanden";
				break;
			case -1006:
				Result = "FECOM: nicht unterstützte Funktion oder Option";

				break;
			case -1010:
				Result = "FECOM: Fehler beim Öffnen des COM-Ports";
				break;
			case -1011:
				Result = "FECOM: Timeout beim Öffnen des COM-Ports";
				break;
			case -1012:
				Result = "FECOM: Fehlerhafter Parameter cPortNr in FECOM_OpenPort";
				break;
			case -1013:
				Result = "FECOM: der Port ist bereits geöffnet";

				break;
			case -1020:
				Result = "FECOM: Unbekannter Port-Handle";
				break;
			case -1021:
				Result = "FECOM: Der übergebene Port-Handle ist null";
				break;
			case -1022:
				Result = "FECOM: Der übergebene Port-Handle ist negativ";
				break;
			case -1023:
				Result = "FECOM: Der übergebene Port-Handle ist unbekannt";

				break;
			case -1030:
				Result = "FECOM: Timeout beim Lesen vom Port";
				break;
			case -1031:
				Result = "FECOM: Kein Sendeprotokoll übergeben";
				break;
			case -1032:
				Result = "FECOM: Fehler im Empfangsprozess";
				break;
			case -1033:
				Result = "FECOM: Fehler beim Initialisieren des Ports";
				break;
			case -1034:
				Result = "FECOM: Fehler beim Löschen des Empfangspuffers";
				break;
			case -1035:
				Result = "FECOM: Fehler beim Löschen des Sendepuffers";
				break;
			case -1036:
				Result = "FECOM: Fehler beim Ändern eines Port-Parameters";
				break;
			case -1037:
				Result = "FECOM: Fehler im Sendeprozess";
				break;
			case -1038:
				Result = "FECOM: Checksummen- und/oder Paritätsfehler";
				break;
			case -1039:
				Result = "FECOM_ERR_READ_PORT_PARA";

				break;
			case -1050:
				Result = "FECOM: Übergabeparameter ist nicht bekannt";
				break;
			case -1051:
				Result = "FECOM: Übergabeparameter zu groß oder zu klein";
				break;
			case -1052:
				Result = "FECOM: Ungerader Parameterstring übergeben";
				break;
			case -1053:
				Result = "FECOM: COM-Port-Nummer außerhalb des gültigen Wertebereichs";
				break;
			case -1054:
				Result = "FECOM: unbekannter Fehlercode";

				break;
			case -1070:
				Result = "FECOM: Überlauf im Empfangspuffer";

				break;
			//   Fehlertexte für FEISC
			case -4000:
				Result = "FEISC: Fehler beim Erzeugen eines neuen Leser-Objekts";
				break;
			case -4001:
				Result = "FEISC: Leere Leser-Liste";
				break;
			case -4002:
				Result = "FEISC: Zeiger auf Übergabeparameter ist NULL";
				break;
			case -4003:
				Result = "FEISC: Kein Systemspeicher mehr";
				break;
			case -4004:
				Result = "FEISC: unbekannter COM-Port";
				break;
			case -4005:
				Result = "FEISC: nicht unterstützte Funktion";
				break;
			case -4006:
				Result = "FEISC: keine USB-Unterstützung (z.B. unter NT4)";
				break;
			case -4007:
				Result = "FEISC: alte FECOM.DLL detektiert";
				break;
			// query errors
			case -4010:
				Result = "FEISC: Kein Datenwert vorhanden";

				break;
			case -4020:
				Result = "FEISC: Reader-Handle ist unkekannt";
				break;
			case -4021:
				Result = "FEISC: Der übergebene Leser-Handlle ist null";
				break;
			case -4022:
				Result = "FEISC: Der übergebene Leser-Handle ist negativ";
				break;
			case -4023:
				Result = "FEISC: Reader-Handle in Reader-Handleliste";
				break;
			case -4024:
				Result = "FEISC: Der übergebene Port-Handle ist negativ";
				break;
			case -4025:
				Result = "FEISC: das erste Byte (MSB) im Port-Handle ist ungültig";

				break;
			case -4030:
				Result = "FEISC: Protokoll-Längenfehler";
				break;
			case -4031:
				Result = "FEISC: Protokoll-Checksummenfehler";
				break;
			case -4032:
				Result = "FEISC: Busy-Timeout";
				break;
			case -4050:
				Result = "FEISC: Unbekannter Übergabeparameter";
				break;
			case -4051:
				Result = "FEISC: Übergabeparameter außerhalb des gültigen Wertebereichs";
				break;
			case -4052:
				Result = "FEISC: Ungerader Parameterstring übergeben";
				break;
			case -4053:
				Result = "FEISC: Parameterstring ist zu lang";
				break;

			//Public Const FEISC_ERR_NO_PLUGIN = -4060
			//Public Const FEISC_ERR_PLUGIN_PRESENT = -4061
			//Public Const FEISC_ERR_UNKNOWN_PLUGIN_ID = -4062
			//Public Const FEISC_ERR_PI_BUILD_DATA = -4063
			//Public Const FEISC_ERR_PI_BUILD_FRAME = -4064
			//Public Const FEISC_ERR_PI_SPLIT_FRAME = -4065
			//Public Const FEISC_ERR_PI_SPLIT_DATA = -4066



			//   Fehlertexte für LUCA
			case -10001:
				Result = "COM-Port: unknown usual parameter";
				break;
			case -10002:
				Result = "COM-Port: unknown port handle";
				break;
			case -10003:
				Result = "COM-Port: to many ports open";
				break;
			case -10004:
				Result = "COM-Port: no more memory";

				break;
			case -10010:
				Result = "COM-Port: error in link identifier";
				break;
			case -10011:
				Result = "COM-Port: syntax error in parameter";
				break;
			case -10012:
				Result = "COM-Port: syntx error in value assignment";
				break;
			case -10013:
				Result = "COM-Port: syntx error in adress assignment";
				break;
			case -10014:
				Result = "COM-Port: parameterstring is to long";
				break;
			case -10016:
				Result = "COM-Port: input/output error";
				break;
			case -10017:
				Result = "COM-Port: timeout";
				break;
			case -10018:
				Result = "COM-Port: buffer is to small for next block";
				break;
			case -10020:
				Result = "COM-Port: value is out of range";
				break;
			case -10021:
				Result = "COM-Port: unknown parameter";
				break;
			case -10022:
				Result = "COM-Port: parameter is write protected";

				break;
			case -10099:
				Result = "COM-Port: not implemented";

				break;
			case -20001:
				Result = "COM-Port: abort";
				break;
			case -20002:
				Result = "COM-Port: modul not found";
				break;
			case -20003:
				Result = "COM-Port: unknown driver modul";
				break;
			case -20005:
				Result = "COM-Port: unknown protocol modul";
				break;
			case -20006:
				Result = "COM-Port: modul is still pushed";
				break;
			case -20007:
				Result = "COM-Port: missing adress";
				break;
			case -20008:
				Result = "COM-Port: missing protocol";

				break;
			case -21000:
				Result = "COM-Port: line is not ready";
				break;
			case -21001:
				Result = "COM-Port: timeout while connecting";
				break;
			case -21002:
				Result = "COM-Port: wrong network adress";
				break;
			case -21003:
				Result = "COM-Port: dial locked";
				break;
			case -21004:
				Result = "COM-Port: no dialtone";
				break;
			case -21005:
				Result = "COM-Port: <listen fehlgeschlagen>";
				break;
			case -21006:
				Result = "COM-Port: abnormal disconnect";

				break;
			case -22000:
				Result = "COM-Port: protocol error";

				break;
			case -23001:
				Result = "COM-Port: access denied";
				break;
			case -23002:
				Result = "COM-Port: authorization error";

				break;
			default:
				Result = "unbekannter Fehlercode";
				break;
		}
		Info_Text = iStatus.ToString() + "/" + Result;
		if (GetReaderText != null) {
			GetReaderText(Info_Text);
		}
		return Result;
	}

    public void New_Init()
    {
        Read_Array = new byte[256];
        Write_Array = new byte[256];
        My_ComArray = new byte[4];
        Config_Array = new byte[14];
        cReqData = new byte[2];
        cRspData = new byte[512];
        Info_Array = new byte[512];
        UID_Array = new byte[12];
        UID_Array24 = new byte[19];
        Key_Array = new byte[10];
        SelMifare_Array = new byte[10];
        Value_Array = new byte[17];
        InfoReader = new string[6];
        ReadMi_Array = new byte[4];
        WriteMi_Array = new byte[22];
        Error_Array = new byte[256];
    }

	#endregion

}

